package com.weiyoubot.client.basekt.activity

import android.os.Bundle
import android.support.v7.app.AppCompatActivity
import android.widget.TextView

import com.weiyoubot.client.R
import com.weiyoubot.client.common.helper.UmengHelper
import com.weiyoubot.client.common.utils.AppManager

abstract class BaseActivity : AppCompatActivity() {

    var isRunning: Boolean = false

    private val pageName: String
        get() {
            val titleView = findViewById(R.id.title)
            return if (titleView != null && titleView is TextView) {
                titleView.text.toString()
            } else ""
        }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        isRunning = true
        AppManager.addActivity(this)
    }

    override fun onResume() {
        super.onResume()
        UmengHelper.onResume(this)
        UmengHelper.onPageStart(pageName)
    }

    override fun onPause() {
        super.onPause()
        UmengHelper.onPause(this)
        UmengHelper.onPageEnd(pageName)
    }

    override fun onDestroy() {
        super.onDestroy()
        isRunning = false
        AppManager.removeActivity(this)
    }
}
