package com.weiyoubot.client.basekt.activity

import android.os.Bundle
import android.view.View
import android.widget.TextView

import com.hannesdorfmann.mosby3.mvp.lce.MvpLceActivity
import com.hannesdorfmann.mosby3.mvp.lce.MvpLceView
import com.weiyoubot.client.R
import com.weiyoubot.client.basekt.BaseLcePresenter
import com.weiyoubot.client.common.helper.UmengHelper
import com.weiyoubot.client.common.utils.AppManager

/**
 * Created by root on 1/20/17.
 */
abstract class BaseLceActivity<CV : View, M, V : MvpLceView<M>, P : BaseLcePresenter<M, V>> : MvpLceActivity<CV, M, V, P>() {

    private var isRunning: Boolean = false

    private val pageName: String
        get() {
            val titleView = findViewById(R.id.title)
            return if (titleView != null && titleView is TextView) {
                titleView.text.toString()
            } else ""
        }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        isRunning = true
        AppManager.addActivity(this)
    }

    override fun onResume() {
        super.onResume()
        UmengHelper.onResume(this)
        UmengHelper.onPageStart(pageName)
    }

    override fun onPause() {
        super.onPause()
        UmengHelper.onPause(this)
        UmengHelper.onPageEnd(pageName)
    }

    override fun onDestroy() {
        super.onDestroy()
        isRunning = false
        AppManager.removeActivity(this)
    }

    override fun getErrorMessage(e: Throwable, pullToRefresh: Boolean): String {
        return getString(if (pullToRefresh) R.string.load_error else R.string.load_error_retry) + "\n" + e.message
    }
}
