package com.weiyoubot.client.common.utils

import android.content.Context
import android.os.Build
import android.text.Html
import android.widget.TextView
import android.widget.Toast

fun TextView.setTextHTML(html: String) {
    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
        this.text = Html.fromHtml(html, Html.FROM_HTML_MODE_LEGACY)
    } else {
        @Suppress("DEPRECATION")
        this.text = Html.fromHtml(html)
    }
}

fun TextView.setTextHTML(htmlStrId: Int) {
    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
        this.text = Html.fromHtml(Utils.getString(htmlStrId), Html.FROM_HTML_MODE_LEGACY)
    } else {
        @Suppress("DEPRECATION")
        this.text = Html.fromHtml(Utils.getString(htmlStrId))
    }
}

fun TextView.setTextHTML(html: String, imageGetter: Html.ImageGetter, tagHandler: Html.TagHandler?) {
    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
        this.text = Html.fromHtml(html, Html.FROM_HTML_MODE_LEGACY, imageGetter, tagHandler)
    } else {
        @Suppress("DEPRECATION")
        this.text = Html.fromHtml(html, imageGetter, tagHandler)
    }
}

fun makeHtmlString(html: String, imageGetter: Html.ImageGetter? = null, tagHandler: Html.TagHandler? = null): CharSequence {
    return if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
        Html.fromHtml(html, Html.FROM_HTML_MODE_LEGACY, imageGetter, tagHandler)
    } else {
        @Suppress("DEPRECATION")
        Html.fromHtml(html, imageGetter, tagHandler)
    }
}

fun Context.toast(message: CharSequence) {
    Toast.makeText(this, message, Toast.LENGTH_SHORT).show()
}