package com.weiyoubot.client.feature.account.adapter

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.View.VISIBLE
import android.view.ViewGroup
import com.weiyoubot.client.R
import com.weiyoubot.client.common.utils.DateUtils
import com.weiyoubot.client.common.utils.Utils
import com.weiyoubot.client.feature.account.CouponConstant
import com.weiyoubot.client.model.bean.userdata.CouponInfo
import kotlinx.android.synthetic.main.coupon_item_view.view.*
import java.text.DecimalFormat

class AccountCouponAdapter : RecyclerView.Adapter<AccountCouponAdapter.CouponViewHolder>() {

    private var data: MutableList<CouponInfo> = mutableListOf()

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): CouponViewHolder {
        return CouponViewHolder(
                LayoutInflater.from(parent.context)
                        .inflate(R.layout.coupon_item_view, parent, false)
        )
    }

    override fun getItemCount() = data.size

    override fun onBindViewHolder(holder: CouponViewHolder, position: Int) = holder.bind(data[position])

    fun swapData(data: MutableList<CouponInfo>) {
        this.data = data
        notifyDataSetChanged()
    }

    class CouponViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        fun bind(item: CouponInfo) = with(itemView) {
            itemView.coupon_valid_time.text = Utils.getString(R.string.coupon_type_validate_until, DateUtils.formatDate("yyyy-MM-dd", item.end * 1000))
            when (item.type) {
                CouponConstant.COUPON_TYPE_DISCOUNT -> {
                    itemView.coupon_type.setText(R.string.coupon_type_discount)
                    itemView.coupon_discount_prefix.visibility = VISIBLE
                    itemView.coupon_discount.text = item.discount.toInt().toString()
                }
                CouponConstant.COUPON_TYPE_PERCENT -> {
                    itemView.coupon_type.setText(R.string.coupon_type_percent)
                    itemView.coupon_discount_suffix.visibility = VISIBLE
                    itemView.coupon_discount.text = DecimalFormat("#.#").format(item.discount * 10)
                }
                CouponConstant.COUPON_TYPE_IMMEDIATE -> {
                    itemView.coupon_type.setText(R.string.coupon_type_immediate)
                    itemView.coupon_discount_prefix.visibility = VISIBLE
                    itemView.coupon_discount.text = item.discount.toInt().toString()
                }
            }
            itemView.coupon_desc.text = item.desc
        }
    }
}