package com.weiyoubot.client.feature.account.view

import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import com.weiyoubot.client.R
import com.weiyoubot.client.basekt.activity.BaseActivity
import com.weiyoubot.client.feature.account.CouponConstant
import com.weiyoubot.client.feature.account.CouponSelectedEvent
import com.weiyoubot.client.feature.account.PaymentConstant
import com.weiyoubot.client.feature.account.adapter.SelectCouponAdapter
import com.weiyoubot.client.model.bean.userdata.CouponInfo
import kotlinx.android.synthetic.main.coupon_select_activity.*
import org.greenrobot.eventbus.EventBus

class CouponSelectActivity : BaseActivity(), SelectCouponAdapter.OnSelectedCouponChanged {

    private var coupons = mutableListOf<CouponInfo>()
    private lateinit var type: String

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.coupon_select_activity)
        coupons = intent.getParcelableArrayListExtra<CouponInfo>(CouponConstant.COUPON_INTENT_KEY_COUPONS)
        type = intent.getStringExtra(PaymentConstant.INTENT_KEY_PAYMENT_VIEW_TYPE)
        val selectedCid = intent.getStringExtra(CouponConstant.COUPON_INTENT_KEY_SELECTED_CID)
        val adapter = SelectCouponAdapter(coupons, selectedCid, this)
        content.layoutManager = LinearLayoutManager(this)
        content.adapter = adapter
        adapter.notifyDataSetChanged()
        back.setOnClickListener {
            setResult(RESULT_CANCELED)
            finish()
        }
    }

    override fun selectedCouponChanged(cid: String, order_discount:Float) {
        EventBus.getDefault().post(CouponSelectedEvent(type, cid, order_discount))
        finish()
    }
}