package com.weiyoubot.client.feature.addgroup.presenter

import com.hannesdorfmann.mosby3.mvp.MvpBasePresenter
import com.weiyoubot.client.common.helper.MQHelper
import com.weiyoubot.client.feature.addgroup.view.AddGroupSuccessGuideMvpView
import com.weiyoubot.client.model.api.CustomerApiClient
import com.weiyoubot.client.model.bean.robots.CustomerQrCode
import com.weiyoubot.client.model.loader.OnDataLoadListener

import android.content.Context

/**
 * Created by root on 11/21/16.
 */
class AddGroupSuccessGuidePresenter : MvpBasePresenter<AddGroupSuccessGuideMvpView>() {

    fun loadCustomerQrCode() {
        CustomerApiClient.requestCustomerQrCode(object : OnDataLoadListener {
            override fun onDataLoaded(data: Any) {
                ifViewAttached {
                    val customerQrCode = data as CustomerQrCode
                    it.updateCustomerQrCode(customerQrCode)
                }
            }

            override fun onDataLoadFailed(isServerError: Boolean, errorCode: Int, errorMessage: String) {}
        })
    }

    fun startCustomerService(context: Context) {
        MQHelper.startConversation(context, "guideline_page")
    }
}
