package com.weiyoubot.client.feature.main.content.complaint

import com.weiyoubot.client.R
import com.weiyoubot.client.model.apikt.ApiClient
import com.weiyoubot.client.model.bean.complaint.exit.Exit
import com.weiyoubot.client.model.bean.complaint.latest.Latest
import com.weiyoubot.client.model.loader.OnDataLoadListener

import org.json.JSONException

/**
 * Created by root on 11/17/16.
 */
object ComplaintHelper {

    fun loadComplaintSuspect(gid: String, listener: OnDataLoadListener) {
        ApiClient.requestComplaintSuspect(gid, listener)
    }

    fun loadComplaintExit(gid: String, day: Int, listener: OnDataLoadListener) {
        ApiClient.requestComplaintExit(gid, day, listener)
    }

    fun loadComplaintLatest(gid: String, listener: OnDataLoadListener) {
        ApiClient.requestComplaintLatest(gid, listener)
    }

    fun exitComplaint(gid: String, exit: Exit, listener: OnDataLoadListener) {
        try {
            ApiClient.exitComplaint(gid, exit, listener)
        } catch (e: JSONException) {
            e.printStackTrace()
        }

    }

    fun exitRepeal(gid: String, exit: Exit, listener: OnDataLoadListener) {
        try {
            ApiClient.exitRepeal(gid, exit, listener)
        } catch (e: JSONException) {
            e.printStackTrace()
        }

    }

    fun latestComplaint(gid: String, latest: Latest, listener: OnDataLoadListener) {
        try {
            ApiClient.latestComplaint(gid, latest, listener)
        } catch (e: JSONException) {
            e.printStackTrace()
        }

    }

    fun latestRepeal(gid: String, latest: Latest, listener: OnDataLoadListener) {
        try {
            ApiClient.latestRepeal(gid, latest, listener)
        } catch (e: JSONException) {
            e.printStackTrace()
        }

    }

    fun switchComplaint(gid: String, status: Int, listener: OnDataLoadListener) {
        try {
            ApiClient.switchComplaint(gid, status, listener)
        } catch (e: JSONException) {
            e.printStackTrace()
        }

    }

    fun getAction(checkedId: Int): String {
        when (checkedId) {
            R.id.complaint_ad -> return "ad"
            R.id.complaint_abuse -> return "abuse"
            R.id.complaint_cheat -> return "cheat"
            R.id.complaint_sexy -> return "sexy"
            R.id.complaint_other -> return "other"
        }
        return ""
    }

}
