package com.weiyoubot.client.feature.main.content.kickout

import com.weiyoubot.client.R
import com.weiyoubot.client.common.utils.Utils
import com.weiyoubot.client.model.bean.kickout.KickOutMember
import com.weiyoubot.client.model.bean.kickout.KickOutSetting

import android.text.TextUtils

/**
 * Created by root on 11/15/16.
 */
object KickOutHelper {

    fun getKickOutSetting(kickOutSettings: List<KickOutSetting>, trigger: Int): KickOutSetting? {
        for (kickOutSetting in kickOutSettings) {
            if (kickOutSetting.trigger == trigger) {
                return kickOutSetting
            }
        }
        return null
    }

    fun getKickOutSettingTriggerText(trigger: Int): String {
        when (trigger) {
            KickOutConstant.TRIGGER_1 -> return Utils.getString(R.string.kick_out_setting_rule_1)
            KickOutConstant.TRIGGER_2 -> return Utils.getString(R.string.kick_out_setting_rule_2)
            KickOutConstant.TRIGGER_3 -> return Utils.getString(R.string.kick_out_setting_rule_3)
            else -> {
            }
        }
        return ""
    }

    fun getKickOutReason(kickOutMember: KickOutMember): String {
        return when (kickOutMember.manner) {
            0 -> if (TextUtils.isEmpty(kickOutMember.executor)) {
                Utils.getString(R.string.kick_out_member_reason_0_somebody)
            } else {
                Utils.getString(R.string.kick_out_member_reason_0, kickOutMember.executor)
            }
            1 -> Utils.getString(R.string.kick_out_member_reason_1)
            2 -> Utils.getString(R.string.kick_out_member_reason_2)
            3 -> Utils.getString(R.string.kick_out_member_reason_3)
            4 -> Utils.getString(R.string.kick_out_member_reason_4)
            5 -> Utils.getString(R.string.kick_out_member_reason_5)
            6 -> Utils.getString(R.string.kick_out_member_reason_6)
            else -> Utils.getString(R.string.kick_out_member_reason_unknown)
        }
    }

    fun isAutoKickOutEnabled(kickOutSettings: List<KickOutSetting>): Boolean {
        for (kickOutSetting in kickOutSettings) {
            if (kickOutSetting.status == 1 && kickOutSetting.trigger != KickOutConstant.TRIGGER_KEYWORD) {
                return true
            }
        }
        return false
    }

    fun getKeywordKickOutSetting(kickOutSettings: List<KickOutSetting>): KickOutSetting? {
        for (kickOutSetting in kickOutSettings) {
            if (kickOutSetting.trigger == KickOutConstant.TRIGGER_KEYWORD) {
                return kickOutSetting
            }
        }
        return null
    }

    fun getScamperKickOutSetting(kickOutSettings: List<KickOutSetting>): KickOutSetting? {
        for (kickOutSetting in kickOutSettings) {
            if (kickOutSetting.trigger == KickOutConstant.TRIGGER_3) {
                return kickOutSetting
            }
        }
        return null
    }

    fun getNormalKickOutSetting(kickOutSettings: List<KickOutSetting>): KickOutSetting? {
        for (kickOutSetting in kickOutSettings) {
            if (kickOutSetting.trigger == KickOutConstant.TRIGGER_2) {
                return kickOutSetting
            }
        }
        return null
    }

    fun getAdminKickOutSetting(kickOutSettings: List<KickOutSetting>): KickOutSetting? {
        for (kickOutSetting in kickOutSettings) {
            if (kickOutSetting.trigger == KickOutConstant.TRIGGER_1) {
                return kickOutSetting
            }
        }
        return null
    }
}
