package com.weiyoubot.client.feature.main.content.kickout

import android.os.Bundle
import android.support.v4.view.ViewPager
import android.support.v7.app.AlertDialog
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.weiyoubot.client.R
import com.weiyoubot.client.basekt.fragment.BaseFragment
import com.weiyoubot.client.common.utils.Utils
import com.weiyoubot.client.common.utils.makeHtmlString
import com.weiyoubot.client.common.view.slidingtab.SlidingTabView
import com.weiyoubot.client.common.view.slidingtab.SlidingTabViewPagerTab
import com.weiyoubot.client.feature.main.content.kickout.view.KickOutBlacklistFragment
import com.weiyoubot.client.feature.main.content.kickout.view.KickOutMembersFragment
import com.weiyoubot.client.feature.main.content.kickout.view.KickOutRecordFragment
import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import java.util.*

/**
 * Created by root on 10/31/16.
 */
class KickOutMainFragment : BaseFragment() {

    private var robotNotOwnerFlag = false
    private var hasShownRobotNotOwnerDialog = false

    override fun onCreateView(inflater: LayoutInflater?, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        EventBus.getDefault().register(this)
        return SlidingTabView(activity)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        val tabs = createMemberTabs()
        val slidingTabView = view as SlidingTabView
        slidingTabView.initViewPager(childFragmentManager, tabs)
        slidingTabView.setOffscreenPageLimit(Utils.getListCount(tabs))
        slidingTabView.addOnPageChangeListener(object : ViewPager.OnPageChangeListener {
            override fun onPageScrolled(position: Int, positionOffset: Float, positionOffsetPixels: Int) {

            }

            override fun onPageSelected(position: Int) {
                if (position == 1 && robotNotOwnerFlag && !hasShownRobotNotOwnerDialog) {
                    hasShownRobotNotOwnerDialog = true
                    AlertDialog.Builder(activity).setTitle(R.string.dialog_title)
                            .setMessage(makeHtmlString(Utils.getString(R.string.kick_out_blacklist_robot_not_group_owner)))
                            .setPositiveButton(R.string.ok, null).show()
                }
            }

            override fun onPageScrollStateChanged(state: Int) {

            }
        })
    }

    private fun createMemberTabs(): List<SlidingTabViewPagerTab> {
        val tabs = ArrayList<SlidingTabViewPagerTab>()

        var bundle = Bundle(arguments)

        val kickOutMembersFragment = KickOutMembersFragment()
        kickOutMembersFragment.arguments = bundle

        val KickOutRecordFragment = KickOutRecordFragment()
        KickOutRecordFragment.arguments = bundle

        val kickOutBlacklistFragment = KickOutBlacklistFragment()
        bundle = Bundle(arguments)
        kickOutBlacklistFragment.arguments = bundle

        tabs.add(SlidingTabViewPagerTab(0, getString(R.string.kick_out_title), kickOutMembersFragment))
        tabs.add(SlidingTabViewPagerTab(1, getString(R.string.kick_out_record_title), KickOutRecordFragment))
        tabs.add(SlidingTabViewPagerTab(2, getString(R.string.kick_out_blacklist_title), kickOutBlacklistFragment))
        return tabs
    }

    override fun onDestroyView() {
        super.onDestroyView()
        EventBus.getDefault().unregister(this)
    }

    @Suppress("UNUSED_PARAMETER")
    @Subscribe
    fun onEvent(event: KickOutRobotNotOwnerEvent) {
        robotNotOwnerFlag = true
    }
}
