package com.weiyoubot.client.feature.main.content.kickout.presenter

import com.hannesdorfmann.mosby3.mvp.MvpBasePresenter
import com.weiyoubot.client.feature.main.content.kickout.KickOutChangeEvent
import com.weiyoubot.client.feature.main.content.kickout.view.KickOutBlacklistMvpView
import com.weiyoubot.client.model.api.ApiClient
import com.weiyoubot.client.model.bean.kickout.KickOutBlacklist
import com.weiyoubot.client.model.loader.OnDataLoadListener

import org.greenrobot.eventbus.EventBus
import org.json.JSONException

/**
 * Created by pgao on 2018/3/24.
 */

class KickOutBlacklistPresenter : MvpBasePresenter<KickOutBlacklistMvpView>() {
    fun loadKickOutBlacklist(gid: String) {
        ApiClient.requestKickOutBlacklist(gid, object : OnDataLoadListener {
            override fun onDataLoaded(data: Any) {
                ifViewAttached { view ->
                    view.updateKickOutBlacklist(data as KickOutBlacklist)
                }
            }

            override fun onDataLoadFailed(isServerError: Boolean, errorCode: Int, errorMessage: String) {
                ifViewAttached { view ->
                    view.updateKickOutBlacklist(KickOutBlacklist())
                }
            }
        })
    }

    fun deleteFromKickOutBlacklist(gid: String, uid: String) {
        try {
            ApiClient.deleteFromKickOutBlacklist(gid, uid, object : OnDataLoadListener {
                override fun onDataLoaded(data: Any) {
                    ifViewAttached {
                        EventBus.getDefault().post(KickOutChangeEvent())
                    }
                }

                override fun onDataLoadFailed(isServerError: Boolean, errorCode: Int, errorMessage: String) {
                    ifViewAttached { view ->
                        view.updateKickOutBlacklist(KickOutBlacklist())
                    }
                }
            })
        } catch (e: JSONException) {
            e.printStackTrace()
        }
    }
}
