package com.weiyoubot.client.feature.main.content.kickout.presenter

import com.hannesdorfmann.mosby3.mvp.MvpBasePresenter
import com.weiyoubot.client.R
import com.weiyoubot.client.common.utils.UIUtils
import com.weiyoubot.client.feature.main.content.kickout.KickOutChangeEvent
import com.weiyoubot.client.feature.main.content.kickout.view.KickOutRecordMvpView
import com.weiyoubot.client.model.api.ApiClient
import com.weiyoubot.client.model.bean.kickout.KickOutBlacklist
import com.weiyoubot.client.model.bean.kickout.KickOutMembers
import com.weiyoubot.client.model.bean.kickout.KickOutSettings
import com.weiyoubot.client.model.loader.OnDataLoadListener

import org.greenrobot.eventbus.EventBus
import org.json.JSONException

/**
 * Created by pgao on 2018/3/24.
 */

class KickOutRecordPresenter : MvpBasePresenter<KickOutRecordMvpView>() {

    fun loadKickOutMembers(gid: String) {
        ApiClient.requestKickOutMembers(gid, object : OnDataLoadListener {
            override fun onDataLoaded(data: Any) {
                ifViewAttached { view ->
                    view.updateKickOutMembers(data as KickOutMembers)
                }
            }

            override fun onDataLoadFailed(isServerError: Boolean, errorCode: Int, errorMessage: String) {
                ifViewAttached { view ->
                    view.updateKickOutMembers(KickOutMembers())
                }
            }
        })
    }
    fun addToKickOutBlacklist(gid: String, uid: String) {
        try {
            ApiClient.addToKickOutBlacklist(gid, uid, object : OnDataLoadListener {
                override fun onDataLoaded(data: Any) {
                    ifViewAttached {
                        EventBus.getDefault().post(KickOutChangeEvent())
                    }
                }

                override fun onDataLoadFailed(isServerError: Boolean, errorCode: Int, errorMessage: String) {
                    ifViewAttached {
                        UIUtils.showFailedToast(R.string.set_failed, errorMessage)
                    }
                }
            })
        } catch (e: JSONException) {
            e.printStackTrace()
        }

    }
}
