package com.weiyoubot.client.feature.main.content.kickout.view

import android.content.Intent
import android.graphics.Color
import android.os.Bundle
import android.support.v7.app.AlertDialog
import android.support.v7.widget.RecyclerView
import android.text.SpannableString
import android.text.Spanned
import android.text.TextUtils
import android.text.method.LinkMovementMethod
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.*
import butterknife.BindView
import butterknife.ButterKnife
import butterknife.OnClick
import butterknife.Unbinder
import com.weiyoubot.client.R
import com.weiyoubot.client.basekt.fragment.BaseMvpFragment
import com.weiyoubot.client.common.clickablespan.AdminClickableSpan
import com.weiyoubot.client.common.clickablespan.CustomerClickableSpan
import com.weiyoubot.client.common.utils.Utils
import com.weiyoubot.client.common.view.SwitchItemView
import com.weiyoubot.client.common.view.TrialView
import com.weiyoubot.client.feature.main.UserDataConstant
import com.weiyoubot.client.feature.main.content.kickout.KickOutChangeEvent
import com.weiyoubot.client.feature.main.content.kickout.KickOutConstant
import com.weiyoubot.client.feature.main.content.kickout.KickOutHelper
import com.weiyoubot.client.feature.main.content.kickout.KickOutRobotNotOwnerEvent
import com.weiyoubot.client.feature.main.content.kickout.presenter.KickOutMembersPresenter
import com.weiyoubot.client.feature.main.content.reply.ReplyConstant
import com.weiyoubot.client.feature.main.content.reply.edit.keywordedit.KeywordEditEvent
import com.weiyoubot.client.feature.main.content.reply.edit.keywordedit.KeywordHelper
import com.weiyoubot.client.feature.main.content.reply.edit.keywordedit.view.KeywordEditActivity
import com.weiyoubot.client.feature.main.content.reply.view.ReplyKeywordContainerView
import com.weiyoubot.client.feature.main.menu.MenuConstant
import com.weiyoubot.client.model.bean.kickout.KickOutSettings
import com.weiyoubot.client.model.bean.userdata.Group
import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe

/**
 * Created by root on 10/31/16.
 */
class KickOutMembersFragment : BaseMvpFragment<KickOutMembersMvpView, KickOutMembersPresenter>(), KickOutMembersMvpView {

    private lateinit var mGid: String

    private var mKickOutSettings: KickOutSettings = KickOutSettings()

    private lateinit var unbinder: Unbinder

    @BindView(R.id.trial_view)
    lateinit var mTrialView: TrialView
    @BindView(R.id.kick_out_tips)
    lateinit var mKickOutTips: TextView
    @BindView(R.id.robot_icon)
    lateinit var mRobotIcon: ImageView
    @BindView(R.id.robot)
    lateinit var mRobot: TextView
    @BindView(R.id.check_owner)
    lateinit var mCheckOwner: Button
    @BindView(R.id.keyword_kick_out_toggle)
    lateinit var mKeywordKickOutToggle: SwitchItemView
    @BindView(R.id.keyword_kick_out_content)
    lateinit var mKeywordKickOutContent: LinearLayout
    @BindView(R.id.trigger_type_group)
    lateinit var mTriggerTypeGroup: RadioGroup
    @BindView(R.id.keyword_kick_out_blacklist_layout)
    lateinit var mKeywordKickOutBlacklistLayout: LinearLayout
    @BindView(R.id.keyword_kick_out_blacklist)
    lateinit var mKeywordKickOutBlacklist: CheckBox
    @BindView(R.id.keyword_kick_out_auto_out)
    lateinit var mKeywordKickOutAutoOut: CheckBox
    @BindView(R.id.keyword_container)
    lateinit var mKeywordContainer: ReplyKeywordContainerView
    @BindView(R.id.keyword_kick_out_text)
    lateinit var mKeywordKickOutText: TextView
    @BindView(R.id.keyword_kick_out_edit_text)
    lateinit var mKeywordKickOutEditText: EditText
    @BindView(R.id.keyword_kick_out_text_edit_box)
    lateinit var mKeywordKickOutTextEditBox: LinearLayout
    @BindView(R.id.keyword_kick_out_text_edit)
    lateinit var mKeywordKickOutTextEdit: ImageView
    @BindView(R.id.scamper_kick_out_content)
    lateinit var mScamperKickOutContent: LinearLayout
    @BindView(R.id.scamper_kick_out_toggle)
    lateinit var mScamperKickOutToggle: SwitchItemView
    @BindView(R.id.scamper_kick_out_text)
    lateinit var mScamperKickOutText: TextView
    @BindView(R.id.scamper_kick_out_edit_text)
    lateinit var mScamperKickOutEditText: EditText
    @BindView(R.id.scamper_kick_out_text_edit_box)
    lateinit var mScamperKickOutTextEditBox: LinearLayout
    @BindView(R.id.scamper_kick_out_text_edit)
    lateinit var mScamperKickOutTextEdit: ImageView
    @BindView(R.id.one_message)
    lateinit var mOneMessage: CheckBox
    @BindView(R.id.one_message_time)
    lateinit var mOneMessageTime: EditText
    @BindView(R.id.one_message_char)
    lateinit var mOneMessageChar: CheckBox
    @BindView(R.id.one_message_char_time)
    lateinit var mOneMessageCharTime: EditText
    @BindView(R.id.series_operation)
    lateinit var mSeriesOperation: CheckBox
    @BindView(R.id.series_time)
    lateinit var mSeriesTime: EditText
    @BindView(R.id.series_strip)
    lateinit var mSeriesStrip: EditText
    @BindView(R.id.series_save)
    lateinit var mSeriesSave: Button
    @BindView(R.id.normal_kick_out_content)
    lateinit var mNormalKickOutContent: LinearLayout
    @BindView(R.id.normal_kick_out_toggle)
    lateinit var mNormalKickOutToggle: SwitchItemView
    @BindView(R.id.normal_kick_out_text)
    lateinit var mNormalKickOutText: TextView
    @BindView(R.id.normal_kick_out_edit_text)
    lateinit var mNormalKickOutEditText: EditText
    @BindView(R.id.normal_kick_out_text_edit_box)
    lateinit var mNormalKickOutTextEditBox: LinearLayout
    @BindView(R.id.normal_kick_out_text_edit)
    lateinit var mNormalKickOutTextEdit: ImageView
    @BindView(R.id.admin_kick_out_content)
    lateinit var mAdminKickOutContent: LinearLayout
    @BindView(R.id.admin_kick_out_toggle)
    lateinit var mAdminKickOutToggle: SwitchItemView
    @BindView(R.id.admin_kick_out_text)
    lateinit var mAdminKickOutText: TextView
    @BindView(R.id.admin_kick_out_edit_text)
    lateinit var mAdminKickOutEditText: EditText
    @BindView(R.id.admin_kick_out_text_edit_box)
    lateinit var mAdminKickOutTextEditBox: LinearLayout
    @BindView(R.id.admin_kick_out_text_edit)
    lateinit var mAdminKickOutTextEdit: ImageView

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        val view = inflater.inflate(R.layout.kick_out_members_fragment, container, false)
        unbinder = ButterKnife.bind(this, view)
        EventBus.getDefault().register(this)
        return view
    }

    override fun onViewCreated(view: View?, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        val group = arguments.getParcelable<Group>(MenuConstant.INTENT_KEY_GROUP)
        val trial = arguments.getBoolean(MenuConstant.INTENT_KEY_TRIAL)
        val permId = arguments.getInt(UserDataConstant.INTENT_KEY_PERM_ID)
        mGid = group!!.gid

        mTrialView.initView(group, trial, permId)

        val tips = Utils.getString(R.string.kick_out_tips)
        val spannableString = SpannableString(tips)
        val adminClickableSpan = AdminClickableSpan(activity)
        val customerClickableSpan = CustomerClickableSpan(activity, "autokick", true)
        val adminIndex = tips.indexOf(Utils.getString(R.string.kick_out_tips_set_admin))
        spannableString.setSpan(adminClickableSpan, adminIndex, adminIndex + 8, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)
        spannableString.setSpan(customerClickableSpan, tips.length - 9, tips.length - 5, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)
        mKickOutTips.text = spannableString
        mKickOutTips.movementMethod = LinkMovementMethod.getInstance()
        mKickOutTips.highlightColor = Color.TRANSPARENT

        loadKickOutSettings()
    }

    override fun createPresenter(): KickOutMembersPresenter {
        return KickOutMembersPresenter()
    }

    private fun loadKickOutSettings() {
        presenter.loadKickOutSettings(mGid)
    }

    override fun updateKickOutSettings(data: KickOutSettings) {
        mKickOutSettings = data
        val isRobotGroupOwner = mKickOutSettings.data.isNotEmpty() && mKickOutSettings.sta == 0
        mRobotIcon.setImageResource(if (isRobotGroupOwner) R.drawable.on else R.drawable.off)
        if (isRobotGroupOwner){
            mRobot.setText(mKickOutSettings.roleTip)
        }else{
            mRobot.setText(R.string.robot_is_not_group_owner)
        }
        mRobot.setTextColor(Utils.getColor(if (isRobotGroupOwner) R.color.common_blue_color else R.color.common_red_color))
        if (isRobotGroupOwner) {
            mCheckOwner.visibility = View.GONE
            mAdminKickOutToggle.visibility = View.VISIBLE
            mNormalKickOutToggle.visibility = View.VISIBLE
            mKeywordKickOutToggle.visibility = View.VISIBLE
            mScamperKickOutToggle.visibility = View.VISIBLE
            mKeywordKickOutBlacklistLayout.visibility = View.VISIBLE
            mKeywordKickOutText.visibility = View.VISIBLE
            mKeywordKickOutTextEdit.visibility = View.VISIBLE
            mKeywordKickOutTextEditBox.visibility = View.GONE
            val keywordKickOutSetting = KickOutHelper.getKeywordKickOutSetting(mKickOutSettings.data)
            val scamperKickOutSetting = KickOutHelper.getScamperKickOutSetting(mKickOutSettings.data)
            val normalKickOutSetting = KickOutHelper.getNormalKickOutSetting(mKickOutSettings.data)
            val adminKickOutSetting = KickOutHelper.getAdminKickOutSetting(mKickOutSettings.data)
            val keywordKickOutOn = keywordKickOutSetting!!.status == 1
            val scamperKickOutOn = scamperKickOutSetting!!.status == 1
            val normalKickOutOn = normalKickOutSetting!!.status == 1
            val adminKickOutOn = adminKickOutSetting!!.status == 1
            mKeywordKickOutText.setText(keywordKickOutSetting.resp);
            mScamperKickOutText.setText(scamperKickOutSetting.resp);
            for(index in scamperKickOutSetting.detail.indices){
                if(scamperKickOutSetting.detail[index].option == KickOutConstant.LINE_COUNT){
                    mOneMessage.isChecked = scamperKickOutSetting.detail[index].enable == 1
                    mOneMessageTime.setText(scamperKickOutSetting.detail[index].count)
                }
                if(scamperKickOutSetting.detail[index].option == KickOutConstant.CHAR_COUNT){
                    mOneMessageChar.isChecked = scamperKickOutSetting.detail[index].enable == 1
                    mOneMessageCharTime.setText(scamperKickOutSetting.detail[index].count)
                }
                if(scamperKickOutSetting.detail[index].option == KickOutConstant.MSG_SPEED){
                    mSeriesOperation.isChecked = scamperKickOutSetting.detail[index].enable == 1
                    mSeriesTime.setText(scamperKickOutSetting.detail[index].sec)
                    mSeriesStrip.setText(scamperKickOutSetting.detail[index].count)
                }
            }
            mNormalKickOutText.setText(normalKickOutSetting.resp);
            mAdminKickOutText.setText(adminKickOutSetting.resp);
            mKeywordKickOutToggle.setSwitchOn(keywordKickOutOn)
            mScamperKickOutToggle.setSwitchOn(scamperKickOutOn)
            mNormalKickOutToggle.setSwitchOn(normalKickOutOn)
            mAdminKickOutToggle.setSwitchOn(adminKickOutOn)
            mKeywordKickOutContent.visibility = if (keywordKickOutOn) View.VISIBLE else View.GONE
            mScamperKickOutContent.visibility = if (scamperKickOutOn) View.VISIBLE else View.GONE
            mNormalKickOutContent.visibility = if (normalKickOutOn) View.VISIBLE else View.GONE
            mAdminKickOutContent.visibility = if (adminKickOutOn) View.VISIBLE else View.GONE
            if (keywordKickOutOn) {
                mKeywordContainer.initKeywordDisplayContainer(keywordKickOutSetting.keyword, keywordKickOutSetting.maxKeywordNum) { v ->
                    when (v.id) {
                        R.id.keyword_add -> startKeywordEditActivity(keywordKickOutSetting.keyword, keywordKickOutSetting.maxKeywordNum)
                        R.id.keyword -> deleteKeyword(v.getTag(R.id.reply_tag_index) as Int)
                    }
                }
                mTriggerTypeGroup.setOnCheckedChangeListener(null)
                mTriggerTypeGroup.check(if (TextUtils.equals(keywordKickOutSetting.matchType, KickOutConstant.KEYWORD_MATCH_TYPE_ACCURATE))
                    R.id.trigger_type_accurate
                else
                    R.id.trigger_type_inaccurate)
                mTriggerTypeGroup.setOnCheckedChangeListener { _, checkedId ->
                    val newKickOutSettings = mKickOutSettings.copy()
                    for (kickOutSetting in newKickOutSettings.data) {
                        if (kickOutSetting.trigger == KickOutConstant.TRIGGER_KEYWORD) {
                            kickOutSetting.matchType = if (checkedId == R.id.trigger_type_accurate)
                                KickOutConstant.KEYWORD_MATCH_TYPE_ACCURATE
                            else
                                KickOutConstant.KEYWORD_MATCH_TYPE_FUZZY
                        }
                    }
                    presenter.saveKickOutSettings(mGid, newKickOutSettings)
                }
                mKeywordKickOutBlacklist.setOnCheckedChangeListener(null)
                mKeywordKickOutBlacklist.isChecked = keywordKickOutSetting.blackStatus == 1
                mKeywordKickOutBlacklist.setOnCheckedChangeListener { _, isChecked ->
                    val newKickOutSettings = mKickOutSettings.copy()
                    for (kickOutSetting in newKickOutSettings.data) {
                        if (kickOutSetting.trigger == KickOutConstant.TRIGGER_KEYWORD) {
                            kickOutSetting.blackStatus = if (isChecked) 1 else 0
                        }
                    }
                    presenter.saveKickOutSettings(mGid, newKickOutSettings)
                }
                mKeywordKickOutAutoOut.setOnCheckedChangeListener(null)
                mKeywordKickOutAutoOut.isChecked = keywordKickOutSetting.including_weapp_and_link == 1
                mKeywordKickOutAutoOut.setOnCheckedChangeListener { _, isChecked ->
                    val newKickOutSettings = mKickOutSettings.copy()
                    for (kickOutSetting in newKickOutSettings.data) {
                        if (kickOutSetting.trigger == KickOutConstant.TRIGGER_KEYWORD) {
                            kickOutSetting.including_weapp_and_link = if (isChecked) 1 else 0
                        }
                    }
                    presenter.saveKickOutSettings(mGid, newKickOutSettings)
                }
            }
        } else {
            mCheckOwner.visibility = View.VISIBLE
//            mAutoKickOutToggle.visibility = View.GONE
            mAdminKickOutToggle.visibility = View.GONE
            mNormalKickOutToggle.visibility = View.GONE
            mKeywordKickOutToggle.visibility = View.GONE
            mScamperKickOutToggle.visibility = View.GONE
            mKeywordKickOutBlacklistLayout.visibility = View.GONE
            EventBus.getDefault().post(KickOutRobotNotOwnerEvent())
        }
    }

    override fun updateGroupOwnerTip(tip: String) {
        mRobot.text = tip
    }

    override fun updateKeywordKickOutOnOff(on: Boolean) {
        val newKickOutSettings = mKickOutSettings.copy()
        for (kickOutSetting in newKickOutSettings.data) {
            if (kickOutSetting.trigger == KickOutConstant.TRIGGER_KEYWORD) {
                kickOutSetting.status = if (on) 1 else 0
            }
        }
        presenter.saveKickOutSettings(mGid, newKickOutSettings)
    }

    override fun updateScamperKickOutOnOff(on: Boolean) {
        val newKickOutSettings = mKickOutSettings.copy()
        for (kickOutSetting in newKickOutSettings.data) {
            if (kickOutSetting.trigger == KickOutConstant.TRIGGER_3) {
                kickOutSetting.status = if (on) 1 else 0
            }
        }
        presenter.saveKickOutSettings(mGid, newKickOutSettings)
    }

    override fun updateNormalKickOutOnOff(on: Boolean) {
        val newKickOutSettings = mKickOutSettings.copy()
        for (kickOutSetting in newKickOutSettings.data) {
            if (kickOutSetting.trigger == KickOutConstant.TRIGGER_2) {
                kickOutSetting.status = if (on) 1 else 0
            }
        }
        presenter.saveKickOutSettings(mGid, newKickOutSettings)
    }

    override fun updateAdminKickOutOnOff(on: Boolean) {
        val newKickOutSettings = mKickOutSettings.copy()
        for (kickOutSetting in newKickOutSettings.data) {
            if (kickOutSetting.trigger == KickOutConstant.TRIGGER_1) {
                kickOutSetting.status = if (on) 1 else 0
            }
        }
        presenter.saveKickOutSettings(mGid, newKickOutSettings)
    }

    @OnClick(R.id.check_owner)
    fun onClick() {
        loadKickOutSettings()
    }

    @OnClick(R.id.keyword_kick_out_text_edit, R.id.keyword_kick_out_text_save, R.id.keyword_kick_out_text_cancel,R.id.scamper_kick_out_text_edit, R.id.scamper_kick_out_text_save, R.id.scamper_kick_out_text_cancel,R.id.series_save,R.id.normal_kick_out_text_edit, R.id.normal_kick_out_text_save, R.id.normal_kick_out_text_cancel,R.id.admin_kick_out_text_edit, R.id.admin_kick_out_text_save, R.id.admin_kick_out_text_cancel)
    fun onClick(view: View) {
        when (view.id) {
            R.id.keyword_kick_out_text_edit -> {
                mKeywordKickOutEditText.setText(mKeywordKickOutText.getText())
                mKeywordKickOutText.setVisibility(View.GONE)
                mKeywordKickOutTextEditBox.setVisibility(View.VISIBLE)
                mKeywordKickOutEditText.setVisibility(View.VISIBLE)
                mKeywordKickOutEditText.setSelection(mKeywordKickOutEditText.getText().length)
                mKeywordKickOutTextEdit.setVisibility(View.GONE)
            }
            R.id.keyword_kick_out_text_save -> if (mKeywordKickOutEditText.getText().length > 40) {
                AlertDialog.Builder(activity).setTitle(R.string.dialog_title)
                        .setMessage(R.string.robot_private_0_verify_text_too_long)
                        .setPositiveButton(R.string.ok, null).show()
            } else {
                mKeywordKickOutEditText.setVisibility(View.GONE)
                mKeywordKickOutTextEditBox.setVisibility(View.GONE)
                mKeywordKickOutText.setVisibility(View.VISIBLE)
                mKeywordKickOutTextEdit.setVisibility(View.VISIBLE)
                val keywordKickOutSetting = KickOutHelper.getKeywordKickOutSetting(mKickOutSettings.data)
                keywordKickOutSetting!!.resp = mKeywordKickOutEditText.getText().toString();
                val newKickOutSettings = mKickOutSettings.copy()
                presenter.saveKickOutSettings(mGid,newKickOutSettings)
            }
            R.id.keyword_kick_out_text_cancel -> {
                mKeywordKickOutEditText.setVisibility(View.GONE)
                mKeywordKickOutTextEditBox.setVisibility(View.GONE)
                mKeywordKickOutText.setVisibility(View.VISIBLE)
                mKeywordKickOutTextEdit.setVisibility(View.VISIBLE)
            }
            R.id.scamper_kick_out_text_edit -> {
                mScamperKickOutEditText.setText(mScamperKickOutText.getText())
                mScamperKickOutText.setVisibility(View.GONE)
                mScamperKickOutTextEditBox.setVisibility(View.VISIBLE)
                mScamperKickOutEditText.setVisibility(View.VISIBLE)
                mScamperKickOutEditText.setSelection(mScamperKickOutEditText.getText().length)
                mScamperKickOutTextEdit.setVisibility(View.GONE)
            }
            R.id.scamper_kick_out_text_save -> if (mScamperKickOutEditText.getText().length > 40) {
                AlertDialog.Builder(activity).setTitle(R.string.dialog_title)
                        .setMessage(R.string.robot_private_0_verify_text_too_long)
                        .setPositiveButton(R.string.ok, null).show()
            } else {
                mScamperKickOutEditText.setVisibility(View.GONE)
                mScamperKickOutTextEditBox.setVisibility(View.GONE)
                mScamperKickOutText.setVisibility(View.VISIBLE)
                mScamperKickOutTextEdit.setVisibility(View.VISIBLE)
                val scamperKickOutSetting = KickOutHelper.getScamperKickOutSetting(mKickOutSettings.data)
                scamperKickOutSetting!!.resp = mScamperKickOutEditText.getText().toString();
                val newKickOutSettings = mKickOutSettings.copy()
                presenter.saveKickOutSettings(mGid,newKickOutSettings)
            }
            R.id.scamper_kick_out_text_cancel -> {
                mScamperKickOutEditText.setVisibility(View.GONE)
                mScamperKickOutTextEditBox.setVisibility(View.GONE)
                mScamperKickOutText.setVisibility(View.VISIBLE)
                mScamperKickOutTextEdit.setVisibility(View.VISIBLE)
            }
            R.id.admin_kick_out_text_edit -> {
                mAdminKickOutEditText.setText(mAdminKickOutText.getText())
                mAdminKickOutText.setVisibility(View.GONE)
                mAdminKickOutTextEditBox.setVisibility(View.VISIBLE)
                mAdminKickOutEditText.setVisibility(View.VISIBLE)
                mAdminKickOutEditText.setSelection(mAdminKickOutEditText.getText().length)
                mAdminKickOutTextEdit.setVisibility(View.GONE)
            }
            R.id.admin_kick_out_text_save -> if (mAdminKickOutEditText.getText().length > 40) {
                AlertDialog.Builder(activity).setTitle(R.string.dialog_title)
                        .setMessage(R.string.robot_private_0_verify_text_too_long)
                        .setPositiveButton(R.string.ok, null).show()
            } else {
                mAdminKickOutEditText.setVisibility(View.GONE)
                mAdminKickOutTextEditBox.setVisibility(View.GONE)
                mAdminKickOutText.setVisibility(View.VISIBLE)
                mAdminKickOutTextEdit.setVisibility(View.VISIBLE)
                val adminKickOutSetting = KickOutHelper.getAdminKickOutSetting(mKickOutSettings.data)
                adminKickOutSetting!!.resp = mAdminKickOutEditText.getText().toString();
                val newKickOutSettings = mKickOutSettings.copy()
                presenter.saveKickOutSettings(mGid,newKickOutSettings)
            }
            R.id.admin_kick_out_text_cancel -> {
                mAdminKickOutEditText.setVisibility(View.GONE)
                mAdminKickOutTextEditBox.setVisibility(View.GONE)
                mAdminKickOutText.setVisibility(View.VISIBLE)
                mAdminKickOutTextEdit.setVisibility(View.VISIBLE)
            }
            R.id.normal_kick_out_text_edit -> {
                mNormalKickOutEditText.setText(mNormalKickOutText.getText())
                mNormalKickOutText.setVisibility(View.GONE)
                mNormalKickOutTextEditBox.setVisibility(View.VISIBLE)
                mNormalKickOutEditText.setVisibility(View.VISIBLE)
                mNormalKickOutEditText.setSelection(mNormalKickOutEditText.getText().length)
                mNormalKickOutTextEdit.setVisibility(View.GONE)
            }
            R.id.normal_kick_out_text_save -> if (mNormalKickOutEditText.getText().length > 40) {
                AlertDialog.Builder(activity).setTitle(R.string.dialog_title)
                        .setMessage(R.string.robot_private_0_verify_text_too_long)
                        .setPositiveButton(R.string.ok, null).show()
            } else {
                mNormalKickOutEditText.setVisibility(View.GONE)
                mNormalKickOutTextEditBox.setVisibility(View.GONE)
                mNormalKickOutText.setVisibility(View.VISIBLE)
                mNormalKickOutTextEdit.setVisibility(View.VISIBLE)
                val normalKickOutSetting = KickOutHelper.getNormalKickOutSetting(mKickOutSettings.data)
                normalKickOutSetting!!.resp = mNormalKickOutEditText.getText().toString();
                val newKickOutSettings = mKickOutSettings.copy()
                presenter.saveKickOutSettings(mGid,newKickOutSettings)
            }
            R.id.normal_kick_out_text_cancel -> {
                mNormalKickOutEditText.setVisibility(View.GONE)
                mNormalKickOutTextEditBox.setVisibility(View.GONE)
                mNormalKickOutText.setVisibility(View.VISIBLE)
                mNormalKickOutTextEdit.setVisibility(View.VISIBLE)
            }
            R.id.series_save->{
                val scamperKickOutSetting = KickOutHelper.getScamperKickOutSetting(mKickOutSettings.data)
                for(index in scamperKickOutSetting!!.detail.indices){
                    if(scamperKickOutSetting.detail[index].option == KickOutConstant.LINE_COUNT){
                        if(mOneMessage.isChecked()){
                            scamperKickOutSetting.detail[index].enable=1
                        }else{
                            scamperKickOutSetting.detail[index].enable=0
                        }
                        scamperKickOutSetting.detail[index].count=mOneMessageTime.getText().toString()
                    }
                    if(scamperKickOutSetting.detail[index].option == KickOutConstant.CHAR_COUNT){
                        if(mOneMessageChar.isChecked()){
                            scamperKickOutSetting.detail[index].enable=1
                        }else{
                            scamperKickOutSetting.detail[index].enable=0
                        }
                        scamperKickOutSetting.detail[index].count=mOneMessageCharTime.getText().toString()
                    }
                    if(scamperKickOutSetting.detail[index].option == KickOutConstant.MSG_SPEED){
                        if(mSeriesOperation.isChecked()){
                            scamperKickOutSetting.detail[index].enable=1
                        }else{
                            scamperKickOutSetting.detail[index].enable=0
                        }
                        scamperKickOutSetting.detail[index].count=mSeriesStrip.getText().toString()
                        scamperKickOutSetting.detail[index].sec=mSeriesTime.getText().toString()
                    }
                }
                val newKickOutSettings = mKickOutSettings.copy()
                presenter.saveKickOutSettings(mGid,newKickOutSettings)
            }
        }
    }

    override fun onDestroyView() {
        super.onDestroyView()
        unbinder.unbind()
        EventBus.getDefault().unregister(this)
    }

    @Subscribe
    fun onEvent(event: KeywordEditEvent) {
        val keywordKickOutSetting = KickOutHelper.getKeywordKickOutSetting(mKickOutSettings.data)
        keywordKickOutSetting!!.keyword = event.trigger
        val newKickOutSettings = mKickOutSettings.copy()
        presenter.saveKickOutSettings(mGid, newKickOutSettings)
    }

    private fun startKeywordEditActivity(keyword: String, keywordMaxCount: Int) {
        val keywordIntent = Intent(context, KeywordEditActivity::class.java)
        keywordIntent.putExtra(ReplyConstant.INTENT_KEY_TRIGGER, keyword)
        keywordIntent.putExtra(ReplyConstant.INTENT_KEY_KEYWORD_MAX_COUNT, keywordMaxCount)
        context.startActivity(keywordIntent)
    }

    private fun deleteKeyword(keywordIndex: Int) {
        val keywordKickOutSetting = KickOutHelper.getKeywordKickOutSetting(mKickOutSettings.data)
        val keywords = keywordKickOutSetting!!.keyword.split("\n".toRegex()).dropLastWhile { it.isEmpty() }.toTypedArray()
        if (keywordIndex < keywords.size) {
            keywords[keywordIndex] = ""
        }
        keywordKickOutSetting.keyword = KeywordHelper.createTrigger(keywords)
        val newKickOutSettings = mKickOutSettings.copy()
        presenter.saveKickOutSettings(mGid, newKickOutSettings)
    }
}
