package com.weiyoubot.client.feature.main.content.member

import com.weiyoubot.client.R
import com.weiyoubot.client.basekt.fragment.BaseFragment
import com.weiyoubot.client.common.utils.Utils
import com.weiyoubot.client.common.view.slidingtab.SlidingTabView
import com.weiyoubot.client.common.view.slidingtab.SlidingTabViewPagerTab
import com.weiyoubot.client.feature.main.content.member.all.view.MemberAllFragment
import com.weiyoubot.client.feature.main.content.member.inactive.view.MemberInactiveFragment
import com.weiyoubot.client.feature.main.content.member.inviter.view.MemberInviterFragment
import com.weiyoubot.client.feature.main.menu.MenuConstant

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup

import java.util.ArrayList

/**
 * Created by root on 10/31/16.
 */
class MemberFragment : BaseFragment() {

    override fun onCreateView(inflater: LayoutInflater?, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return SlidingTabView(activity)
    }

    override fun onViewCreated(view: View?, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        val tabs = createMemberTabs()
        val slidingTabView = view as SlidingTabView?
        slidingTabView!!.initViewPager(childFragmentManager, tabs)
        slidingTabView.setOffscreenPageLimit(Utils.getListCount(tabs))

        if (arguments.getBoolean(MenuConstant.INTENT_KEY_SET_ADMIN)) {
            slidingTabView.currentItem = 0
        }
    }

    private fun createMemberTabs(): List<SlidingTabViewPagerTab> {
        val tabs = ArrayList<SlidingTabViewPagerTab>()

        var bundle = Bundle(arguments)

        val inactiveFragment = MemberInactiveFragment()
        inactiveFragment.arguments = bundle

        val inviterFragment = MemberInviterFragment()
        bundle = Bundle(arguments)
        inviterFragment.arguments = bundle

        val allFragment = MemberAllFragment()
        bundle = Bundle(arguments)
        allFragment.arguments = bundle

        tabs.add(SlidingTabViewPagerTab(0, getString(R.string.member_all), allFragment))
        tabs.add(SlidingTabViewPagerTab(1, getString(R.string.member_inactive), inactiveFragment))
        tabs.add(SlidingTabViewPagerTab(2, getString(R.string.member_invite), inviterFragment))
        return tabs
    }
}
