package com.weiyoubot.client.feature.main.content.member.all.presenter

import com.weiyoubot.client.R
import com.weiyoubot.client.basekt.BaseLcePresenter
import com.weiyoubot.client.common.utils.UIUtils
import com.weiyoubot.client.feature.main.content.member.MemberHelper
import com.weiyoubot.client.feature.main.content.member.all.view.MemberAllMvpView
import com.weiyoubot.client.model.bean.member.Member
import com.weiyoubot.client.model.bean.member.all.MemberAll
import com.weiyoubot.client.model.bean.member.all.ModifyLevel
import com.weiyoubot.client.model.loader.OnDataLoadListener

import android.content.Context

/**
 * Created by root on 11/7/16.
 */
class MemberAllPresenter : BaseLcePresenter<MemberAll, MemberAllMvpView>() {
    override fun loadData(pullToRefresh: Boolean, params: MutableMap<String, Any>, listener: OnDataLoadListener) {
        MemberHelper.loadMemberAll(params, listener)
    }

    fun deleteMembers(context: Context, gid: String, selectMembers: List<Member>, entry: String) {
        MemberHelper.deleteMembers(context, gid, selectMembers, entry, object : OnDataLoadListener {
            override fun onDataLoaded(data: Any) {
                ifViewAttached { view ->
                    view.deleteMembersSuccess(selectMembers)
                }
            }

            override fun onDataLoadFailed(isServerError: Boolean, errorCode: Int, errorMessage: String) {
                ifViewAttached {
                    UIUtils.showFailedToast(R.string.member_delete_failed, errorMessage)
                }
            }
        })
    }

    fun modifyMemberLevel(gid: String, member: Member, level: Int) {
        MemberHelper.modifyMemberLevel(gid, member.username, level, object : OnDataLoadListener {
            override fun onDataLoaded(data: Any) {
                ifViewAttached { view ->
                    val modifyLevel = data as ModifyLevel
                    view.modifyMemberLevelSuccess(member, level, modifyLevel.code)
                }
            }

            override fun onDataLoadFailed(isServerError: Boolean, errorCode: Int, errorMessage: String) {
                ifViewAttached {
                    UIUtils.showFailedToast(R.string.member_level_modify_failed, errorMessage)
                }
            }
        })
    }
}
