package com.weiyoubot.client.feature.main.content.member.inactive.presenter

import com.weiyoubot.client.R
import com.weiyoubot.client.basekt.BaseLcePresenter
import com.weiyoubot.client.common.utils.UIUtils
import com.weiyoubot.client.feature.main.content.member.MemberHelper
import com.weiyoubot.client.feature.main.content.member.inactive.view.MemberInactiveMvpView
import com.weiyoubot.client.model.bean.member.Member
import com.weiyoubot.client.model.bean.member.inactive.MemberInactive
import com.weiyoubot.client.model.loader.OnDataLoadListener

import android.content.Context

/**
 * Created by root on 11/4/16.
 */
class MemberInactivePresenter : BaseLcePresenter<MemberInactive, MemberInactiveMvpView>() {

    override fun loadData(pullToRefresh: Boolean, params: MutableMap<String, Any>, listener: OnDataLoadListener) {
        MemberHelper.loadMemberInactive(params, listener)
    }

    fun deleteMembers(context: Context, gid: String, selectMembers: List<Member>, entry: String) {
        MemberHelper.deleteMembers(context, gid, selectMembers, entry, object : OnDataLoadListener {
            override fun onDataLoaded(data: Any) {
                ifViewAttached { view ->
                    view.deleteMembersSuccess(selectMembers)
                }
            }

            override fun onDataLoadFailed(isServerError: Boolean, errorCode: Int, errorMessage: String) {
                ifViewAttached {
                    UIUtils.showFailedToast(R.string.member_delete_failed, errorMessage)
                }
            }
        })
    }
}
