package com.weiyoubot.client.feature.main.content.reply.edit.respedit.video.adapter

import android.content.Context
import android.text.TextUtils
import android.view.View
import android.view.View.GONE
import android.view.View.VISIBLE
import android.widget.ImageView
import android.widget.TextView
import com.hannesdorfmann.annotatedadapter.annotation.ViewField
import com.hannesdorfmann.annotatedadapter.annotation.ViewType
import com.weiyoubot.client.R
import com.weiyoubot.client.base.AnnotatedAdapter
import com.weiyoubot.client.common.utils.ImageUtils
import com.weiyoubot.client.common.utils.Utils
import com.weiyoubot.client.model.bean.material.MaterialData

/**
 * Created by root on 11/14/16.
 */
class RespEditVideoSelectAdapter(context: Context) : AnnotatedAdapter<List<MaterialData>>(context), RespEditVideoSelectAdapterBinder, View.OnClickListener {
    companion object {
        @ViewType(
                layout = R.layout.resp_edit_video_select_item_view,
                views = [
                    ViewField(id = R.id.image, name = "image", type = ImageView::class),
                    ViewField(id = R.id.selected, name = "selected", type = ImageView::class),
                    ViewField(id = R.id.video_name, name = "videoName", type = TextView::class),
                    ViewField(id = R.id.video_length, name = "videoLength", type = TextView::class)
                ])
        const val VIEW_TYPE_ITEM = 0
    }

    var selectedIndex = 0

    override fun getItemCount(): Int {
        return Utils.getListCount(mData)
    }

    override fun bindViewHolder(vh: RespEditVideoSelectAdapterHolders.VIEW_TYPE_ITEMViewHolder, position: Int) {
        vh.itemView.tag = position
        vh.itemView.setOnClickListener(this)
        ImageUtils.setImage(mContext, vh.image, mData[position].mate.thumb)
        vh.selected.visibility = if (position == selectedIndex) VISIBLE else GONE
        if (TextUtils.equals(mData[position].mate.title, "")) {
            vh.videoName.text = Utils.getString(R.string.material_name_default)
        } else {
            vh.videoName.text = mData[position].mate.title
        }
        vh.videoLength.text = Utils.secToTime(mData[position].mate.size.toInt())
    }

    override fun onClick(v: View) {
        val position = v.tag as Int
        selectedIndex = position
        notifyDataSetChanged()
    }
}
