package com.weiyoubot.client.feature.main.content.reply.edit.respedit.video.presenter

import android.annotation.SuppressLint
import android.content.Context
import android.support.v7.app.AlertDialog
import android.support.v7.widget.GridLayoutManager
import android.view.LayoutInflater
import com.hannesdorfmann.mosby3.mvp.MvpBasePresenter
import com.weiyoubot.client.R
import com.weiyoubot.client.common.utils.UIUtils
import com.weiyoubot.client.common.utils.Utils
import com.weiyoubot.client.feature.main.content.reply.edit.respedit.video.adapter.RespEditVideoSelectAdapter
import com.weiyoubot.client.feature.main.content.reply.edit.respedit.video.view.RespEditVideoMvpView
import com.weiyoubot.client.feature.material.MaterialHelper
import com.weiyoubot.client.model.api.ApiParamKeys
import com.weiyoubot.client.model.bean.material.Material
import com.weiyoubot.client.model.loader.OnDataLoadListener
import kotlinx.android.synthetic.main.resp_edit_select_content_view.view.*
import java.util.*

/**
 * Created by root on 12/1/16.
 */
class RespEditVideoPresenter : MvpBasePresenter<RespEditVideoMvpView>() {

    fun loadMaterialVideo(context: Context) {
        val params = HashMap<String, Any>()
        params[ApiParamKeys.MTYPE] = ApiParamKeys.MTYPE_VALUE_VIDEO
        MaterialHelper.loadMaterial(params, object : OnDataLoadListener {
            @SuppressLint("InflateParams")
            override fun onDataLoaded(data: Any) {
                ifViewAttached {
                    val materials = (data as Material).data
                    if (Utils.isListEmpty(materials)) {
                        UIUtils.showToast(R.string.reply_resp_edit_material_video_empty)
                        return@ifViewAttached
                    }
                    val selectContentView = LayoutInflater.from(context).inflate(R.layout.resp_edit_select_content_view, null)
                    selectContentView.recycler_view.layoutManager = GridLayoutManager(context, 3)
                    val adapter = RespEditVideoSelectAdapter(context)
                    adapter.data = materials
                    selectContentView.recycler_view.adapter = adapter
                    AlertDialog.Builder(context).setTitle(R.string.select_video).setView(selectContentView).setPositiveButton(R.string.ok) { _, _ ->
                        it.addMaterialVideoSuccess(materials[adapter.selectedIndex])
                    }.setNegativeButton(R.string.cancel, null).show()
                }
            }

            override fun onDataLoadFailed(isServerError: Boolean, errorCode: Int, errorMessage: String) {}
        })
    }
}
