package com.weiyoubot.client.feature.main.content.reply.edit.respedit.video.view

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.weiyoubot.client.R
import com.weiyoubot.client.base.fragment.BaseMvpFragment
import com.weiyoubot.client.feature.main.content.reply.edit.respedit.video.presenter.RespEditVideoPresenter
import com.weiyoubot.client.model.bean.material.MaterialData
import kotlinx.android.synthetic.main.resp_edit_video_fragment.*

/**
 * Created by root on 11/11/16.
 */
class RespEditVideoFragment : BaseMvpFragment<RespEditVideoMvpView, RespEditVideoPresenter>(), RespEditVideoMvpView {
    interface VideoAddedListener {
        fun onVideoAdded(materialData: MaterialData)
    }

    lateinit var videoAddedListener: VideoAddedListener

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.resp_edit_video_fragment, container, false)
    }

    override fun onViewCreated(view: View?, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        material_select.setOnClickListener {
            presenter.loadMaterialVideo(activity)
        }
    }

    override fun createPresenter(): RespEditVideoPresenter {
        return RespEditVideoPresenter()
    }

    override fun addMaterialVideoSuccess(material: MaterialData) {
        if (::videoAddedListener.isInitialized) {
            videoAddedListener.onVideoAdded(material)
        }
    }
}
