package com.weiyoubot.client.feature.main.content.statistics.history.view

import com.weiyoubot.client.R
import com.weiyoubot.client.basekt.fragment.BaseLceFragment
import com.weiyoubot.client.common.utils.DateUtils
import com.weiyoubot.client.common.view.recycleviewdecoration.CardItemDecoration
import com.weiyoubot.client.feature.main.UserDataConstant
import com.weiyoubot.client.feature.main.content.statistics.history.adapter.StatisticsHistoryAdapter
import com.weiyoubot.client.feature.main.content.statistics.history.adapter.StatisticsHistoryAdapter.OnQueryClickListener
import com.weiyoubot.client.feature.main.content.statistics.history.presenter.StatisticsHistoryPresenter
import com.weiyoubot.client.feature.main.menu.MenuConstant
import com.weiyoubot.client.model.api.ApiParamKeys
import com.weiyoubot.client.model.bean.statistics.history.StatisticsHistory
import com.weiyoubot.client.model.bean.userdata.Group

import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup

import java.util.HashMap

/**
 * Created by root on 11/1/16.
 */
class StatisticsHistoryFragment : BaseLceFragment<RecyclerView, StatisticsHistory, StatisticsHistoryMvpView, StatisticsHistoryPresenter>(), StatisticsHistoryMvpView {

    private lateinit var mGid: String
    private lateinit var mAdapter: StatisticsHistoryAdapter
    private var mStatisticsHistory: StatisticsHistory? = null

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.lce_fragment, container, false)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        val group = arguments!!.getParcelable<Group>(MenuConstant.INTENT_KEY_GROUP)
        val trial = arguments!!.getBoolean(MenuConstant.INTENT_KEY_TRIAL)
        val permId = arguments!!.getInt(UserDataConstant.INTENT_KEY_PERM_ID)
        mGid = group!!.gid

        mAdapter = StatisticsHistoryAdapter(context!!, group, trial, permId, object:OnQueryClickListener {
            override fun onQueryClick() {
                loadData(true)
            }
        })

        contentView.layoutManager = LinearLayoutManager(activity)
        contentView.addItemDecoration(CardItemDecoration())
        contentView.adapter = mAdapter

        loadData(false)
    }

    override fun createPresenter(): StatisticsHistoryPresenter {
        return StatisticsHistoryPresenter()
    }

    override fun loadData(pullToRefresh: Boolean) {
        val params = HashMap<String, Any>()
        params[ApiParamKeys.GID] = mGid
        params[ApiParamKeys.START] = DateUtils.toUTCTimeInSecond(mAdapter.startTime)
        params[ApiParamKeys.END] = DateUtils.toUTCTimeInSecond(mAdapter.endTime)
        presenter.loadData(pullToRefresh, params)
    }

    override fun setData(data: StatisticsHistory) {
        mStatisticsHistory = data
        mAdapter.data = data
        mAdapter.notifyDataSetChanged()
    }
}
