package com.weiyoubot.client.feature.massmessage.presenter

import com.weiyoubot.client.R
import com.weiyoubot.client.basekt.BaseLcePresenter
import com.weiyoubot.client.common.utils.UIUtils
import com.weiyoubot.client.feature.massmessage.MassMessageEditSuccessEvent
import com.weiyoubot.client.feature.massmessage.MassMessageRemoveSuccessEvent
import com.weiyoubot.client.feature.massmessage.view.MassMessageListMvpView
import com.weiyoubot.client.model.apikt.ApiClient
import com.weiyoubot.client.model.bean.massmessage.MassMessageList
import com.weiyoubot.client.model.bean.massmessage.MassMessageListData
import com.weiyoubot.client.model.loader.OnDataLoadListener
import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import org.json.JSONException

/**
 * Created by root on 6/27/17.
 */
abstract class MassMessageListPresenterAbstract : BaseLcePresenter<MassMessageList, MassMessageListMvpView>() {
    @Suppress("UNUSED_PARAMETER")
    @Subscribe
    fun onEvent(event: MassMessageEditSuccessEvent) {
        ifViewAttached { view ->
            view.clearLastMid()
            view.loadData(true)
        }
    }

    @Subscribe
    fun onEvent(event: MassMessageRemoveSuccessEvent) {
        ifViewAttached { view ->
            view.deleteMassMessageSuccess(event.mmid)
            view.loadData(true)
        }
    }

    abstract fun deleteMassMessage(massMessageListData: MassMessageListData)

    abstract fun switchOnOffMassMessage(massMessageListData: MassMessageListData, status: Int)

    override fun attachView(view: MassMessageListMvpView) {
        super.attachView(view)
        EventBus.getDefault().register(this)
    }

    override fun detachView() {
        super.detachView()
        EventBus.getDefault().unregister(this)
    }
}