package com.weiyoubot.client.feature.massmessage.presenter

import com.weiyoubot.client.R
import com.weiyoubot.client.common.utils.UIUtils
import com.weiyoubot.client.model.apikt.ApiClient
import com.weiyoubot.client.model.bean.massmessage.MassMessageListData
import com.weiyoubot.client.model.loader.OnDataLoadListener
import org.json.JSONException

/**
 * Created by root on 6/27/17.
 */
class MassMessageListPresenterTypePrivate : MassMessageListPresenterAbstract() {

    lateinit var mRid: String

    override fun loadData(pullToRefresh: Boolean, params: MutableMap<String, Any>, listener: OnDataLoadListener) {
        ApiClient.listPrivateMassMessage(params, listener)
    }

    override fun deleteMassMessage(massMessageListData: MassMessageListData) {
        try {
            ApiClient.deletePrivateMassMessage(massMessageListData.mmid, 0, 1, mRid, object : OnDataLoadListener {
                override fun onDataLoaded(data: Any) {
                    ifViewAttached { view ->
                        view.deleteMassMessageSuccess(massMessageListData.mmid)
                    }
                }

                override fun onDataLoadFailed(isServerError: Boolean, errorCode: Int, errorMessage: String) {
                    ifViewAttached {
                        UIUtils.showFailedToast(R.string.mass_message_delete_failed, errorMessage)
                    }
                }
            })
        } catch (e: JSONException) {
            e.printStackTrace()
        }

    }

    override fun switchOnOffMassMessage(massMessageListData: MassMessageListData, status: Int) {
        try {
            ApiClient.switchStatusPrivateMassMessage(massMessageListData.mmid, status, mRid, object : OnDataLoadListener {
                override fun onDataLoaded(data: Any) {
                    ifViewAttached { view ->
                        view.switchOnOffMassMessageSuccess(massMessageListData, status)
                    }
                }

                override fun onDataLoadFailed(isServerError: Boolean, errorCode: Int, errorMessage: String) {
                    ifViewAttached {
                        UIUtils.showFailedToast(R.string.mass_message_delete_failed, errorMessage)
                    }
                }
            })
        } catch (e: JSONException) {
            e.printStackTrace()
        }
    }
}