package com.weiyoubot.client.feature.massmessage.view

import android.content.Intent
import android.os.Bundle
import android.support.v7.app.AlertDialog
import butterknife.BindView
import butterknife.ButterKnife
import butterknife.OnClick
import com.weiyoubot.client.R
import com.weiyoubot.client.basekt.activity.BaseActivity
import com.weiyoubot.client.common.utils.Utils
import com.weiyoubot.client.common.utils.makeHtmlString
import com.weiyoubot.client.common.view.slidingtab.SlidingTabView
import com.weiyoubot.client.common.view.slidingtab.SlidingTabViewPagerTab
import com.weiyoubot.client.feature.main.UserDataHelper
import com.weiyoubot.client.feature.robots.view.RobotsActivity
import java.util.*

/**
 * Created by root on 3/2/17.
 */
class MassMessageActivity : BaseActivity() {

    @BindView(R.id.sliding_tab_view)
    lateinit var mSlidingTabView: SlidingTabView

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_mass_message)
        ButterKnife.bind(this)

        val tabs = createMassMessageTabs()
        mSlidingTabView.initViewPager(supportFragmentManager, tabs)
        mSlidingTabView.setOffscreenPageLimit(Utils.getListCount(tabs))

        if (UserDataHelper.hasPrivateRobotNotOnline()) {
            AlertDialog.Builder(this)
                    .setTitle(R.string.dialog_title)
                    .setMessage(makeHtmlString(Utils.getString(R.string.mass_message_robot_not_online)))
                    .setPositiveButton(R.string.ok) { _, _ ->
                        val intent = Intent(this@MassMessageActivity, RobotsActivity::class.java)
                        startActivity(intent)
                    }.show()
        }
    }

    private fun createMassMessageTabs(): List<SlidingTabViewPagerTab> {
        val tabs = ArrayList<SlidingTabViewPagerTab>()
        val listFragment = MassMessageListFragment()
        tabs.add(SlidingTabViewPagerTab(0, getString(R.string.mass_message_list), listFragment))
        val recordFragment = MassMessageRecordFragmentTypeGroup()
        tabs.add(SlidingTabViewPagerTab(1, getString(R.string.mass_message_record), recordFragment))
        return tabs
    }

    @OnClick(R.id.back)
    fun onClick() {
        finish()
    }
}
