package com.weiyoubot.client.feature.massmessage.view

import android.app.DatePickerDialog
import android.app.TimePickerDialog
import android.content.Intent
import android.os.Bundle
import android.support.v7.widget.RecyclerView
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.View.VISIBLE
import android.view.ViewGroup
import android.widget.*
import butterknife.BindView
import butterknife.ButterKnife
import butterknife.OnClick
import butterknife.Unbinder
import com.weiyoubot.client.R
import com.weiyoubot.client.basekt.fragment.BaseLceFragment
import com.weiyoubot.client.common.utils.DateUtils
import com.weiyoubot.client.common.utils.LaunchUtils
import com.weiyoubot.client.common.utils.UIUtils
import com.weiyoubot.client.common.utils.Utils
import com.weiyoubot.client.common.view.recyclerviewmanager.FullyLinearLayoutManager
import com.weiyoubot.client.feature.main.content.reply.ReplyConstant
import com.weiyoubot.client.feature.main.content.reply.edit.respedit.RespEditEvent
import com.weiyoubot.client.feature.main.content.reply.edit.respedit.view.RespEditActivity
import com.weiyoubot.client.feature.main.content.reply.view.ReplyRespContainerView
import com.weiyoubot.client.feature.main.content.reply.view.ReplyWeekdayContainerView
import com.weiyoubot.client.feature.massmessage.MassMessageConstant
import com.weiyoubot.client.feature.massmessage.MassMessageEditSuccessEvent
import com.weiyoubot.client.feature.massmessage.MassMessageRemoveSuccessEvent
import com.weiyoubot.client.feature.massmessage.adapter.MassMessageEditAdapterTypeGroup
import com.weiyoubot.client.feature.massmessage.presenter.MassMessageEditPresenterTypeGroup
import com.weiyoubot.client.feature.webview.UrlConstant.TUTORIAL_NEW_TYPE_URL
import com.weiyoubot.client.model.api.ApiParamKeys
import com.weiyoubot.client.model.bean.massmessage.*
import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import java.util.*

/**
 * Created by root on 6/27/17.
 */
class MassMessageEditFragmentTypeGroup : BaseLceFragment<ScrollView, MassMessageDetailTypeGroup, MassMessageEditMvpViewTypeGroup, MassMessageEditPresenterTypeGroup>(),
        MassMessageEditMvpViewTypeGroup, View.OnClickListener, ReplyWeekdayContainerView.OnWeekdaySelectedChangeListener {

    private var mMmid: String? = null
    private var mCount: String? = "2"
    private var mIsAdd: Boolean = false
    private var mMassMessageData: MassMessageDetailDataTypeGroup = MassMessageDetailDataTypeGroup()
    private lateinit var mAdapterTypeGroup: MassMessageEditAdapterTypeGroup
    private lateinit var unbinder: Unbinder
    private var mMassMessageSettings: MassMessageList = MassMessageList()

    @BindView(R.id.resp_container)
    lateinit var mRespContainer: ReplyRespContainerView
    @BindView(R.id.group_container)
    lateinit var mGroupContainer: RecyclerView
    @BindView(R.id.no_repeat)
    lateinit var mNoRepeat: RadioButton
    @BindView(R.id.repeat_everyday)
    lateinit var mRepeatEveryday: RadioButton
    @BindView(R.id.weekday_container)
    lateinit var mWeekdayContainer: ReplyWeekdayContainerView
    @BindView(R.id.send_tips)
    lateinit var mSendTips: TextView
    @BindView(R.id.date_select)
    lateinit var mDateSelect: LinearLayout
    @BindView(R.id.date)
    lateinit var mDate: TextView
    @BindView(R.id.time)
    lateinit var mTime: TextView
    @BindView(R.id.tutorial_title)
    lateinit var mTutorialTitle: TextView
    @BindView(R.id.tutorial_message)
    lateinit var mTutorialMessage: TextView
    @BindView(R.id.tutorial_thumb)
    lateinit var mTutorialThumb: ImageView
    @BindView(R.id.save)
    lateinit var mSave: Button
    @BindView(R.id.delete)
    lateinit var mDelete: Button
    @BindView(R.id.at_all)
    lateinit var mAtAll: CheckBox
    @BindView(R.id.mass_title)
    lateinit var mMassTitle: EditText

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        val view = inflater.inflate(R.layout.mass_message_edit_fragment_type_group, container, false)
        unbinder = ButterKnife.bind(this, view)
        EventBus.getDefault().register(this)
        return view
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        var bundle: Bundle?= getArguments();
        mMmid= bundle!!.getString(MassMessageConstant.INTENT_KEY_MASS_MMID);
        mCount = bundle!!.getString(MassMessageConstant.MAX_COUNT);
        //mMmid = arguments?.getString(MassMessageConstant.INTENT_KEY_MASS_MMID)
        //mCount = arguments?.getString(MassMessageConstant.MAX_COUNT)
        mIsAdd = mMmid.isNullOrBlank()

        mAdapterTypeGroup = MassMessageEditAdapterTypeGroup(activity!!)
        mGroupContainer.layoutManager = FullyLinearLayoutManager(activity)
        mGroupContainer.adapter = mAdapterTypeGroup
        mWeekdayContainer.setOnWeekdaySelectedChangeListener(this)
        mTutorialTitle.text = Utils.getString(R.string.tutorial_new_response_type_title)
        mTutorialMessage.text = Utils.getString(R.string.tutorial_new_response_type_subtitle)
        mTutorialThumb.setImageDrawable(Utils.getDrawable(R.drawable.tutorial_new_type))

        if (mIsAdd) {
            mDelete.visibility = View.GONE
            // 新建
            mMassMessageData = MassMessageDetailDataTypeGroup()
            mMassMessageData.respType = "composite"
            mMassMessageData.resp = mutableListOf()
            mMassMessageData.trigger = MassMessageTrigger()
            val calendar = DateUtils.getCalendar()
            calendar.set(Calendar.SECOND, 0)
            calendar.set(Calendar.MILLISECOND, 0)
            mMassMessageData.trigger.timestamp = calendar.timeInMillis / 1000 // 当前时间精确到分，以秒为单位
            mMassMessageData.trigger.wkday = ""
            mMassMessageData.grouping = mutableListOf()
            mMassMessageData.groups = mutableListOf()

            updateRespView()
            updateRepeatView()

            loadMassMessageGroup()
        } else {
            mDelete.visibility = View.VISIBLE
            // 编辑
            loadData(false)
        }
    }

    override fun createPresenter(): MassMessageEditPresenterTypeGroup {
        return MassMessageEditPresenterTypeGroup()
    }

    override fun loadData(pullToRefresh: Boolean) {
        val params = HashMap<String, Any>()
        mMmid?.let { it ->
            params[ApiParamKeys.MMID] = it
        }
        presenter.loadData(pullToRefresh, params)
    }

    override fun setData(data: MassMessageDetailTypeGroup) {
        mMassMessageData = data.data
        mMassTitle.setText(data.data.title)
        updateRespView()
        updateRepeatView()

        val massMessageGroupData = MassMessageGroupData()
        massMessageGroupData.grouping = mMassMessageData.grouping
        massMessageGroupData.groups = mMassMessageData.groups
        massMessageGroupData.limits = mMassMessageData.limits
        updateMassMessageGroup(massMessageGroupData)
    }

    @Suppress("unused")
    fun reset() {
        mMassMessageData.resp.clear()
        mMassMessageData.trigger.timestamp = DateUtils.getCalendar().timeInMillis / 1000 // 当前时间，以秒为单位
        mMassMessageData.trigger.wkday = ""
        mMassMessageData.grouping.clear()
        mMassMessageData.groups.clear()

        updateRespView()
        updateRepeatView()
        mAdapterTypeGroup.reset()
    }

    private fun updateRespView() {
        mRespContainer.initRespDisplayContainer(mMassMessageData.resp, true, this, mCount!!.toInt())
    }

    private fun updateRepeatView() {
        val wkday = mMassMessageData.trigger.wkday
        if (TextUtils.isEmpty(wkday)) {
            mNoRepeat.isChecked = true
            mRepeatEveryday.isChecked = false
            mWeekdayContainer.setWeekdays("")
            mDateSelect.isEnabled = true
            mDateSelect.alpha = 1f
        } else {
            mNoRepeat.isChecked = false
            val splitWkday = wkday.split(",".toRegex()).dropLastWhile { it.isEmpty() }.toTypedArray()
            mRepeatEveryday.isChecked = splitWkday.size == 7
            mWeekdayContainer.setWeekdays(wkday)
            mDateSelect.isEnabled = false
            mDateSelect.alpha = 0.54f
        }
        val timeInMillis = mMassMessageData.trigger.timestamp * 1000
        mDate.text = DateUtils.formatDate("yyyy/MM/dd", timeInMillis)
        mTime.text = DateUtils.formatDate("HH:mm", timeInMillis)
        mAtAll.isChecked = mMassMessageData.at_all == 1
    }

    private fun loadMassMessageGroup() {
        presenter.loadMassMessageGroup()
    }

    override fun updateMassMessageGroup(massMessageGroupData: MassMessageGroupData) {
        if (massMessageGroupData.limits > 0) {
            mSendTips.visibility = VISIBLE
            mSendTips.text = Utils.getString(R.string.mass_message_send_tips, massMessageGroupData.limits)
        }
        mAdapterTypeGroup.data = massMessageGroupData
        mAdapterTypeGroup.notifyDataSetChanged()
    }

    @OnClick(R.id.no_repeat, R.id.repeat_everyday, R.id.date_select, R.id.time_select, R.id.save, R.id.cancel, R.id.tutorial, R.id.delete)
    override fun onClick(view: View) {
        val calendar = DateUtils.getCalendar()
        calendar.timeInMillis = mMassMessageData.trigger.timestamp * 1000
        when (view.id) {
            R.id.no_repeat -> {
                mMassMessageData.trigger.wkday = ""
                updateRepeatView()
            }
            R.id.repeat_everyday -> {
                mMassMessageData.trigger.wkday = "1,2,3,4,5,6,7"
                updateRepeatView()
            }
            R.id.date_select -> DatePickerDialog(activity, DatePickerDialog.OnDateSetListener { _, year, monthOfYear, dayOfMonth ->
                calendar.set(Calendar.YEAR, year)
                calendar.set(Calendar.MONTH, monthOfYear)
                calendar.set(Calendar.DAY_OF_MONTH, dayOfMonth)
                val timeInMillis = calendar.timeInMillis
                mMassMessageData.trigger.timestamp = timeInMillis / 1000
                mDate.text = DateUtils.formatDate("yyyy/MM/dd", timeInMillis)
            }, calendar.get(Calendar.YEAR), calendar.get(Calendar.MONTH), calendar.get(Calendar.DAY_OF_MONTH)).show()
            R.id.time_select -> TimePickerDialog(context, TimePickerDialog.OnTimeSetListener { _, hourOfDay, minute ->
                calendar.set(Calendar.HOUR_OF_DAY, hourOfDay)
                calendar.set(Calendar.MINUTE, minute)
                val timeInMillis = calendar.timeInMillis
                mMassMessageData.trigger.timestamp = timeInMillis / 1000
                mTime.text = DateUtils.formatDate("HH:mm", timeInMillis)
            }, calendar.get(Calendar.HOUR_OF_DAY), calendar.get(Calendar.MINUTE), true).show()
            R.id.save -> {
                mSave.isEnabled = false
                if (Utils.isListEmpty(mMassMessageData.resp)) {
                    UIUtils.showToast(R.string.reply_resp_empty)
                    return
                }
                val selectedGroupInfos = mAdapterTypeGroup.mSelectedGroupInfos
                if (Utils.isListEmpty(selectedGroupInfos)) {
                    UIUtils.showToast(R.string.mass_message_group_empty)
                    return
                }
                mMassMessageData.title = mMassTitle.text.toString()
                mMassMessageData.groups.clear()
                mMassMessageData.grouping.clear()
                for (groupInfo in selectedGroupInfos) {
                    if (TextUtils.isEmpty(groupInfo.ggid)) {
                        mMassMessageData.groups.add(groupInfo)
                    } else {
                        mMassMessageData.grouping.add(groupInfo)
                    }
                }
                mMassMessageData.at_all = if (mAtAll.isChecked) 1 else 0
                presenter.saveMassMessage(mIsAdd, mMassMessageData)
            }
            R.id.cancel -> activity!!.finish()
        // 以下是在其他View里面设置的点击监听
            R.id.resp_add -> startRespEditActivity(-1)
            R.id.resp_edit -> startRespEditActivity(view.getTag(R.id.reply_tag_index) as Int)
            R.id.resp_delete -> deleteResp(view.getTag(R.id.reply_tag_index) as Int)
            R.id.tutorial -> LaunchUtils.startWebViewActivity(context, Utils.getString(R.string.tutorial_new_response_type_title), TUTORIAL_NEW_TYPE_URL)
            R.id.delete -> presenter.deleteMassMessage(mMassMessageData)
        }
    }

    override fun saveMassMessageSuccess() {
        EventBus.getDefault().post(MassMessageEditSuccessEvent())
        activity?.finish()
        mSave.isEnabled = true
    }

    override fun deleteMassMessageSuccess(messageData: MassMessageDetailDataTypeGroup) {
        EventBus.getDefault().post(MassMessageRemoveSuccessEvent(messageData.mmid))
        activity?.finish()
        mSave.isEnabled = true
    }

    override fun saveMassMessageFailed() {
        mSave.isEnabled = true
    }

    private fun deleteResp(respIndex: Int) {
        mMassMessageData.resp.removeAt(respIndex)
        updateRespView()
    }

    private fun startRespEditActivity(index: Int) {
        val respAddIntent = Intent(activity, RespEditActivity::class.java)
        respAddIntent.putExtra(ReplyConstant.INTENT_KEY_RESP_INDEX, index)
        respAddIntent.putExtra(ReplyConstant.INTENT_KEY_RESP, if (index == -1) null else mMassMessageData.resp[index])
        startActivity(respAddIntent)
    }

    @Subscribe
    fun onEvent(event: RespEditEvent) {
        if (event.index == -1) {
            mMassMessageData.resp.add(event.resp)
        } else {
            mMassMessageData.resp[event.index] = event.resp.clone()
        }
        updateRespView()
    }

    override fun onWeekdaySelectedChange(weekdays: String) {
        mMassMessageData.trigger.wkday = weekdays
        updateRepeatView()
    }

    override fun onDestroyView() {
        super.onDestroyView()
        unbinder.unbind()
        EventBus.getDefault().unregister(this)
    }
}
