package com.weiyoubot.client.feature.massmessage.view

import android.app.DatePickerDialog
import android.app.TimePickerDialog
import android.content.Intent
import android.os.Bundle
import android.support.v7.widget.RecyclerView
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.View.GONE
import android.view.View.VISIBLE
import android.view.ViewGroup
import android.widget.*
import butterknife.BindView
import butterknife.ButterKnife
import butterknife.OnClick
import butterknife.Unbinder
import com.weiyoubot.client.R
import com.weiyoubot.client.basekt.fragment.BaseLceFragment
import com.weiyoubot.client.common.utils.DateUtils
import com.weiyoubot.client.common.utils.UIUtils
import com.weiyoubot.client.common.utils.Utils
import com.weiyoubot.client.common.view.recyclerviewmanager.FullyLinearLayoutManager
import com.weiyoubot.client.feature.main.content.reply.ReplyConstant
import com.weiyoubot.client.feature.main.content.reply.edit.respedit.RespEditEvent
import com.weiyoubot.client.feature.main.content.reply.edit.respedit.view.RespEditActivity
import com.weiyoubot.client.feature.main.content.reply.view.ReplyRespContainerView
import com.weiyoubot.client.feature.main.content.reply.view.ReplyWeekdayContainerView
import com.weiyoubot.client.feature.massmessage.MassMessageConstant
import com.weiyoubot.client.feature.massmessage.MassMessageEditSuccessEvent
import com.weiyoubot.client.feature.massmessage.MassMessageRemoveSuccessEvent
import com.weiyoubot.client.feature.massmessage.adapter.MassMessageEditAdapterTypePrivate
import com.weiyoubot.client.feature.massmessage.presenter.MassMessageEditPresenterTypePrivate
import com.weiyoubot.client.model.api.ApiParamKeys
import com.weiyoubot.client.model.bean.massmessage.*
import org.greenrobot.eventbus.EventBus
import org.greenrobot.eventbus.Subscribe
import java.util.*

/**
 * Created by root on 6/27/17.
 */
class MassMessageEditFragmentTypePrivate : BaseLceFragment<ScrollView, MassMessageDetailTypePrivate, MassMessageEditMvpViewTypePrivate, MassMessageEditPresenterTypePrivate>(),
        MassMessageEditMvpViewTypePrivate, View.OnClickListener, ReplyWeekdayContainerView.OnWeekdaySelectedChangeListener, MassMessageEditAdapterTypePrivate.FriendsDeleteListener {
    private var mMmid: String? = null
    private lateinit var mRid: String
    private var mIsAdd: Boolean = false
    private var mMassMessageData: MassMessageDetailDataTypePrivate = MassMessageDetailDataTypePrivate()
    private lateinit var mAdapter: MassMessageEditAdapterTypePrivate
    private lateinit var unbinder: Unbinder
    private var mSelectedCids = mutableSetOf<String>()
    private var mSelectedInit = false
    private var mMassMessageFriendData = MassMessageFriendData()

    @BindView(R.id.resp_container)
    lateinit var mRespContainer: ReplyRespContainerView
    @BindView(R.id.friends_container)
    lateinit var mFriendsContainer: RecyclerView
    @BindView(R.id.repeat_condition)
    lateinit var mRepeatCondition: LinearLayout
    @BindView(R.id.no_repeat)
    lateinit var mNoRepeat: RadioButton
    @BindView(R.id.repeat_periodical)
    lateinit var mRepeatPeriodical: RadioButton
    @BindView(R.id.send_now)
    lateinit var mSendNow: RadioButton
    @BindView(R.id.weekday_container)
    lateinit var mWeekdayContainer: ReplyWeekdayContainerView
    @BindView(R.id.date_select)
    lateinit var mDateSelect: LinearLayout
    @BindView(R.id.date)
    lateinit var mDate: TextView
    @BindView(R.id.time)
    lateinit var mTime: TextView
    @BindView(R.id.save)
    lateinit var mSave: Button
    @BindView(R.id.delete)
    lateinit var mDelete: Button
    @BindView(R.id.mass_title)
    lateinit var mMassTitle: EditText
    @BindView(R.id.selected_friends_tip)
    lateinit var mSelectedFriendsTip: TextView

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        val view = inflater.inflate(R.layout.mass_message_edit_fragment_type_private, container, false)
        unbinder = ButterKnife.bind(this, view)
        EventBus.getDefault().register(this)
        return view
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        mMmid = arguments!!.getString(MassMessageConstant.INTENT_KEY_MASS_MMID)
        mRid = arguments!!.getString(MassMessageConstant.INTENT_KEY_RID)
        mIsAdd = mMmid.isNullOrBlank()

        mAdapter = MassMessageEditAdapterTypePrivate(activity!!, this)
        mFriendsContainer.layoutManager = FullyLinearLayoutManager(activity)
        mFriendsContainer.adapter = mAdapter
        mWeekdayContainer.setOnWeekdaySelectedChangeListener(this)

        if (mIsAdd) {
            mDelete.visibility = View.GONE
            // 新建
            mMassMessageData = MassMessageDetailDataTypePrivate()
            mMassMessageData.resp = mutableListOf()
            mMassMessageData.trigger = MassMessageTrigger()
            val calendar = DateUtils.getCalendar()
            calendar.set(Calendar.SECOND, 0)
            calendar.set(Calendar.MILLISECOND, 0)
            mMassMessageData.trigger.timestamp = calendar.timeInMillis / 1000 // 当前时间精确到分，以秒为单位
            mMassMessageData.trigger.wkday = ""
            mMassMessageData.friendGrouping = mutableListOf()
            mMassMessageData.friendLabelClass = mutableListOf()

            updateRespView()
            updateRepeatView()
            updateFriendsView()
        } else {
            mDelete.visibility = View.VISIBLE
            // 编辑
            loadData(false)
        }
    }

    override fun createPresenter(): MassMessageEditPresenterTypePrivate {
        return MassMessageEditPresenterTypePrivate()
    }

    override fun loadData(pullToRefresh: Boolean) {
        val params = HashMap<String, Any>()
        params[ApiParamKeys.MMID] = mMmid!!
        presenter.loadData(pullToRefresh, params)
    }

    override fun setData(data: MassMessageDetailTypePrivate) {
        mMassMessageData = data.data
        mMassTitle.setText(data.data.title)
        updateRespView()
        updateRepeatView()

        mMassMessageFriendData.friendGrouping = mMassMessageData.friendGrouping
        mMassMessageFriendData.friendLabelClass = mMassMessageData.friendLabelClass
        mMassMessageFriendData.friendListType = mMassMessageData.friendListType
        updateFriendsView()
    }

    @Suppress("unused")
    fun reset() {
        mMassMessageData.resp.clear()
        mMassMessageData.trigger.timestamp = DateUtils.getCalendar().timeInMillis / 1000 // 当前时间，以秒为单位
        mMassMessageData.trigger.wkday = ""
        mMassMessageData.friendGrouping.clear()
        mMassMessageData.friendLabelClass.clear()

        updateRespView()
        updateRepeatView()
    }

    private fun updateRespView() {
        mRespContainer.initRespDisplayContainer(mMassMessageData.resp, true, this)
    }

    private fun updateRepeatView() {
        val wkday = mMassMessageData.trigger.wkday
        if (TextUtils.isEmpty(wkday)) {
            if (mMassMessageData.isInstant == 1) {
                mNoRepeat.isChecked = false
                mRepeatPeriodical.isChecked = false
                mSendNow.isChecked = true
                mRepeatCondition.visibility = GONE
            } else {
                mNoRepeat.isChecked = true
                mRepeatPeriodical.isChecked = false
                mSendNow.isChecked = false
                mRepeatCondition.visibility = VISIBLE
                mWeekdayContainer.visibility = GONE
                mDateSelect.isEnabled = true
                mDateSelect.alpha = 1f
            }
        } else {
            mNoRepeat.isChecked = false
            mRepeatPeriodical.isChecked = true
            mSendNow.isChecked = false
            mRepeatCondition.visibility = VISIBLE
            mWeekdayContainer.visibility = VISIBLE
            mWeekdayContainer.setWeekdays(wkday)
            mDateSelect.isEnabled = false
            mDateSelect.alpha = 0.54f
        }
        val timeInMillis = mMassMessageData.trigger.timestamp * 1000
        mDate.text = DateUtils.formatDate("yyyy/MM/dd", timeInMillis)
        mTime.text = DateUtils.formatDate("HH:mm", timeInMillis)
    }

    private fun updateFriendsView() {
        val selectedFriendsData = MassMessageFriendData(friendListType = mMassMessageFriendData.friendListType)
        for (group in mMassMessageFriendData.friendGrouping) {
            val selectedGroup = MassMessageFriendGrouping(groupingNum = group.groupingNum)
            for (contact in group.list) {
                if (contact.status == 1) {
                    mSelectedCids.add(contact.cid)
                    selectedGroup.list.add(contact)
                }
            }
            if (selectedGroup.list.size > 0) {
                selectedFriendsData.friendGrouping.add(selectedGroup)
            }
        }
        for (group in mMassMessageFriendData.friendLabelClass) {
            val selectedLabel = MassMessageFriendLabel(labelName = group.labelName)
            for (contact in group.list) {
                if (contact.status == 1) {
                    mSelectedCids.add(contact.cid)
                    selectedLabel.list.add(contact)
                }
            }
            if (selectedLabel.list.size > 0) {
                selectedFriendsData.friendLabelClass.add(selectedLabel)
            }
        }
        mSelectedFriendsTip.text = Utils.getString(R.string.mass_message_select_friends_tips, mSelectedCids.size)
        mAdapter.data = selectedFriendsData
        mAdapter.notifyDataSetChanged()
    }

    override fun updateMassMessageFriends(massMessageFriendData: MassMessageFriendData) {
        mSelectedCids = mutableSetOf()
        mSelectedInit = true
        mMassMessageFriendData = massMessageFriendData
        updateFriendsView()
    }

    @OnClick(R.id.no_repeat, R.id.repeat_periodical, R.id.send_now, R.id.date_select, R.id.time_select, R.id.save, R.id.cancel, R.id.delete, R.id.select_friends)
    override fun onClick(view: View) {
        val calendar = DateUtils.getCalendar()
        calendar.timeInMillis = mMassMessageData.trigger.timestamp * 1000
        when (view.id) {
            R.id.no_repeat -> {
                mMassMessageData.trigger.wkday = ""
                mMassMessageData.isInstant = 0
                updateRepeatView()
            }
            R.id.repeat_periodical -> {
                mMassMessageData.trigger.wkday = "1,2,3,4,5,6,7"
                mMassMessageData.isInstant = 0
                updateRepeatView()
            }
            R.id.send_now -> {
                mMassMessageData.trigger.wkday = ""
                mMassMessageData.isInstant = 1
                updateRepeatView()
            }
            R.id.date_select -> DatePickerDialog(activity, DatePickerDialog.OnDateSetListener { _, year, monthOfYear, dayOfMonth ->
                calendar.set(Calendar.YEAR, year)
                calendar.set(Calendar.MONTH, monthOfYear)
                calendar.set(Calendar.DAY_OF_MONTH, dayOfMonth)
                val timeInMillis = calendar.timeInMillis
                mMassMessageData.trigger.timestamp = timeInMillis / 1000
                mDate.text = DateUtils.formatDate("yyyy/MM/dd", timeInMillis)
            }, calendar.get(Calendar.YEAR), calendar.get(Calendar.MONTH), calendar.get(Calendar.DAY_OF_MONTH)).show()
            R.id.time_select -> TimePickerDialog(context, TimePickerDialog.OnTimeSetListener { _, hourOfDay, minute ->
                calendar.set(Calendar.HOUR_OF_DAY, hourOfDay)
                calendar.set(Calendar.MINUTE, minute)
                val timeInMillis = calendar.timeInMillis
                mMassMessageData.trigger.timestamp = timeInMillis / 1000
                mTime.text = DateUtils.formatDate("HH:mm", timeInMillis)
            }, calendar.get(Calendar.HOUR_OF_DAY), calendar.get(Calendar.MINUTE), true).show()
            R.id.save -> {
                mSave.isEnabled = false
                if (Utils.isListEmpty(mMassMessageData.resp)) {
                    UIUtils.showToast(R.string.reply_resp_empty)
                    return
                }
                if (mSelectedCids.size == 0) {
                    UIUtils.showToast(R.string.friend_selected_empty)
                    return
                }
                mMassMessageData.rid = mRid
                mMassMessageData.mmid = mMmid ?: ""
                mMassMessageData.title = mMassTitle.text.toString()
                mMassMessageData.friendGrouping.clear()
                mMassMessageData.friendLabelClass.clear()
                mMassMessageData.friends = (mSelectedCids.map { MassMessageFriendWithCid(cid = it) }).toMutableList()
                mMassMessageData.friendListType = mMassMessageFriendData.friendListType
                presenter.saveMassMessage(mIsAdd, mMassMessageData)
            }
            R.id.cancel -> activity!!.finish()
        // 以下是在其他View里面设置的点击监听
            R.id.resp_add -> startRespEditActivity(-1)
            R.id.resp_edit -> startRespEditActivity(view.getTag(R.id.reply_tag_index) as Int)
            R.id.resp_delete -> deleteResp(view.getTag(R.id.reply_tag_index) as Int)
            R.id.delete -> presenter.deleteMassMessage(mMassMessageData)
            R.id.select_friends -> startSelectFriendsActivity()
        }
    }

    override fun saveMassMessageSuccess() {
        EventBus.getDefault().post(MassMessageEditSuccessEvent())
        activity?.finish()
        mSave.isEnabled = true
    }

    override fun deleteMassMessageSuccess(messageData: MassMessageDetailDataTypePrivate) {
        EventBus.getDefault().post(MassMessageRemoveSuccessEvent(messageData.mmid))
        activity?.finish()
        mSave.isEnabled = true
    }

    override fun saveMassMessageFailed() {
        mSave.isEnabled = true
    }

    private fun deleteResp(respIndex: Int) {
        mMassMessageData.resp.removeAt(respIndex)
        updateRespView()
    }

    private fun startRespEditActivity(index: Int) {
        val respAddIntent = Intent(activity, RespEditActivity::class.java)
        respAddIntent.putExtra(ReplyConstant.INTENT_KEY_RESP_INDEX, index)
        respAddIntent.putExtra(ReplyConstant.INTENT_KEY_RESP, if (index == -1) null else mMassMessageData.resp[index])
        startActivity(respAddIntent)
    }

    private fun startSelectFriendsActivity() {
        val selectFriendsIntent = Intent(activity, MassMessageSelectFriendsActivity::class.java)
        selectFriendsIntent.putExtra(MassMessageConstant.INTENT_KEY_RID, mRid)
        selectFriendsIntent.putExtra(MassMessageConstant.INTENT_KEY_MASS_MMID, mMmid ?: "")
        selectFriendsIntent.putExtra(MassMessageConstant.INTENT_KEY_FRIENDS_MODE, mMassMessageFriendData.friendListType)
        selectFriendsIntent.putExtra(MassMessageConstant.INTENT_KEY_SELCTED_INIT, mSelectedInit)
        selectFriendsIntent.putStringArrayListExtra(MassMessageConstant.INTENT_KEY_SELCTED_FRIENDS, ArrayList(mSelectedCids))
        startActivity(selectFriendsIntent)
    }

    @Subscribe
    fun onEvent(event: RespEditEvent) {
        if (event.index == -1) {
            mMassMessageData.resp.add(event.resp)
        } else {
            mMassMessageData.resp[event.index] = event.resp.clone()
        }
        updateRespView()
    }

    override fun onWeekdaySelectedChange(weekdays: String) {
        mMassMessageData.trigger.wkday = weekdays
        updateRepeatView()
    }

    override fun onDestroyView() {
        super.onDestroyView()
        unbinder.unbind()
        EventBus.getDefault().unregister(this)
    }

    override fun onFriendsDeleted(cids: MutableSet<String>) {
        mSelectedCids.removeAll(cids)
        mSelectedInit = true
        val groupDelList = mutableListOf<MassMessageFriendGrouping>()
        for (group in mMassMessageFriendData.friendGrouping) {
            if (group.list.map { it.cid }.intersect(cids).isNotEmpty()) {
                groupDelList.add(group)
            }
        }
        val labelDelList = mutableListOf<MassMessageFriendLabel>()
        mMassMessageFriendData.friendGrouping.removeAll(groupDelList)
        for (group in mMassMessageFriendData.friendLabelClass) {
            if (group.list.map { it.cid }.intersect(cids).isNotEmpty()) {
                labelDelList.add(group)
            }
        }
        mMassMessageFriendData.friendLabelClass.removeAll(labelDelList)
        updateFriendsView()
    }
}
