package com.weiyoubot.client.feature.massmessage.view

import com.weiyoubot.client.R
import com.weiyoubot.client.basekt.activity.BaseActivity
import com.weiyoubot.client.common.utils.Utils
import com.weiyoubot.client.feature.massmessage.MassMessageConstant

import android.os.Bundle
import android.widget.TextView

import butterknife.BindView
import butterknife.ButterKnife
import butterknife.OnClick

/**
 * Created by root on 6/29/17.
 */
class MassMessageRecordEditActivity : BaseActivity() {

    @BindView(R.id.title)
    lateinit var mTitle: TextView

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_mass_message_edit)
        ButterKnife.bind(this)

        val mmid = intent.getStringExtra(MassMessageConstant.INTENT_KEY_MASS_MMID)
        val massType = intent.getIntExtra(MassMessageConstant.INTENT_KEY_MASS_TYPE, MassMessageConstant.MASS_TYPE_GROUP)
        val rid = intent.getStringExtra(MassMessageConstant.INTENT_KEY_RID)
        val count = intent.getIntExtra(MassMessageConstant.MAX_COUNT, 2)
        mTitle.text = Utils.getString(if (mmid == null) R.string.mass_message_add else R.string.mass_message_record_edit)

        if (massType == MassMessageConstant.MASS_TYPE_PRIVATE) {
            val massMessageEditFragment = MassMessageEditFragmentTypePrivate()
            val bundle = Bundle()
            bundle.putString(MassMessageConstant.INTENT_KEY_MASS_MMID, mmid)
            bundle.putInt(MassMessageConstant.INTENT_KEY_MASS_TYPE, massType)
            bundle.putString(MassMessageConstant.INTENT_KEY_RID, rid)
            massMessageEditFragment.arguments = bundle
            supportFragmentManager.beginTransaction().add(R.id.content, massMessageEditFragment).commitAllowingStateLoss()
        } else {
            val massMessageEditFragment = MassMessageEditFragmentTypeGroup()
            val bundle = Bundle()
            bundle.putString(MassMessageConstant.INTENT_KEY_MASS_MMID, mmid)
            bundle.putString(MassMessageConstant.MAX_COUNT, count.toString())
            massMessageEditFragment.arguments = bundle
            supportFragmentManager.beginTransaction().add(R.id.content, massMessageEditFragment).commitAllowingStateLoss()
        }
    }

    @OnClick(R.id.back)
    fun onClick() {
        finish()
    }
}
