package com.weiyoubot.client.feature.robotprivate.view

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import butterknife.BindView
import butterknife.ButterKnife
import butterknife.Unbinder
import com.weiyoubot.client.R
import com.weiyoubot.client.basekt.fragment.BaseFragment
import com.weiyoubot.client.common.utils.Utils
import com.weiyoubot.client.common.view.slidingtab.SlidingTabView
import com.weiyoubot.client.common.view.slidingtab.SlidingTabViewPagerTab
import com.weiyoubot.client.feature.massmessage.MassMessageConstant
import com.weiyoubot.client.feature.massmessage.view.MassMessageListFragment
import com.weiyoubot.client.feature.massmessage.view.MassMessageRecordFragmentTypePrivate
import com.weiyoubot.client.feature.robots.RobotConstant
import java.util.*

/**
 * Created by root on 5/10/17.
 */
class RobotPrivate5Fragment : BaseFragment() {
    private lateinit var mRid: String
    private lateinit var unbinder: Unbinder

    @BindView(R.id.sliding_tab_view)
    lateinit var mSlidingTabView: SlidingTabView

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        val view = inflater.inflate(R.layout.robot_private_5_fragment, container, false)
        unbinder = ButterKnife.bind(this, view)
        return view
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        mRid = arguments!!.getString(RobotConstant.INTENT_KEY_RID)
        val tabs = createMassMessageTabs()
        mSlidingTabView.initViewPager(fragmentManager, tabs)
        mSlidingTabView.setOffscreenPageLimit(Utils.getListCount(tabs))
        mSlidingTabView.currentItem = 1
    }

    private fun createMassMessageTabs(): List<SlidingTabViewPagerTab> {
        val tabs = ArrayList<SlidingTabViewPagerTab>()
        val tipsFragment = RobotPrivate5TipsFragment()
        tabs.add(SlidingTabViewPagerTab(0, getString(R.string.robot_private_tips_5_title), tipsFragment))
        val listFragment = MassMessageListFragment()
        val bundle = Bundle(arguments)
        bundle.putInt(MassMessageConstant.INTENT_KEY_MASS_TYPE, MassMessageConstant.MASS_TYPE_PRIVATE)
        bundle.putString(MassMessageConstant.INTENT_KEY_RID, mRid)
        listFragment.arguments = bundle
        tabs.add(SlidingTabViewPagerTab(1, getString(R.string.mass_message_list), listFragment))
        val recordFragment = MassMessageRecordFragmentTypePrivate()
        recordFragment.arguments = bundle
        tabs.add(SlidingTabViewPagerTab(2, getString(R.string.mass_message_record), recordFragment))
        return tabs
    }

    override fun onDestroyView() {
        super.onDestroyView()
        unbinder.unbind()
    }
}
