package com.weiyoubot.client.feature.robots.view

import android.app.Activity
import android.app.Dialog
import android.os.Bundle
import com.umeng.socialize.media.UMImage
import com.weiyoubot.client.R
import com.weiyoubot.client.common.helper.UmengHelper
import com.weiyoubot.client.common.utils.ImageUtils
import com.weiyoubot.client.common.utils.setTextHTML
import com.weiyoubot.client.model.api.CustomerApiClient
import com.weiyoubot.client.model.bean.robots.CustomerQrCode
import com.weiyoubot.client.model.loader.OnDataLoadListener
import kotlinx.android.synthetic.main.customer_robot_dialog.*

class CustomerRobotDialog(var activity: Activity) : Dialog(activity, R.style.TransparentDialog) {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.customer_robot_dialog)
        setCancelable(false)
        tips.setTextHTML(R.string.customer_robot_tips)
        close_btn.setOnClickListener { dismiss() }
        added.setOnClickListener { dismiss() }
        CustomerApiClient.requestCustomerQrCode(object : OnDataLoadListener {
            override fun onDataLoaded(data: Any) {
                if (isShowing) {
                    val customerQrCode = data as CustomerQrCode
                    ImageUtils.setImage(activity, qr_code, customerQrCode.url)
                    qr_code.setOnClickListener {
                        val image = UMImage(activity, customerQrCode.url)
                        UmengHelper.shareImageUrl(activity, image)
                    }
                }
            }

            override fun onDataLoadFailed(isServerError: Boolean, errorCode: Int, errorMessage: String) {}
        })
    }
}
