package com.weiyoubot.client.model.apikt

import android.text.TextUtils

import com.weiyoubot.client.common.utils.CookieUtils

import java.io.IOException
import java.util.HashSet

import okhttp3.Interceptor
import okhttp3.Response

/**
 * Created by root on 3/9/17.
 */
class SaveCookiesInterceptor : Interceptor {
    @Throws(IOException::class)
    override fun intercept(chain: Interceptor.Chain): Response {
        val originalResponse = chain.proceed(chain.request())
        if (!TextUtils.isEmpty(originalResponse.header("Set-Cookie"))) {
            val cookie = HashSet<String>()
            for (header in originalResponse.headers("Set-Cookie")) {
                cookie.add(header)
            }
            CookieUtils.setCookie(cookie)
        }
        return originalResponse
    }
}
